63$





    4th_86 version 4.02            GLOSSARY                   page  1
    
    1. Stack manipulation ----------------------------------------     2
    2. return stack       ----------------------------------------     4
    3. memory             ----------------------------------------     5
    4. string operators   ----------------------------------------     7
    5. structure control  ----------------------------------------     9
            General comparison techniques  -----------------------    10
            Loop control                   -----------------------    10
            Iterative loop control         -----------------------    12
            Forth Conditional execution    -----------------------    13
            Assembly Conditional execution -----------------------    16
    6. definition headers      -----------------------------------    18
    7. definition terminators  -----------------------------------    20
    8. definition flags        -----------------------------------    21
    9. variable and constant definitions  ------------------------    22
    10. dictionary management  -----------------------------------    23
    11. vocabularies           -----------------------------------    25
    12. Editing and source code-----------------------------------    26
    13. Compilation                -------------------------------    27
            Loading disk files     -------------------------------    27
            Load option switches   -------------------------------    28
            Compiler control words -------------------------------    29
    14. system variables                --------------------------    32
            System memory configuration --------------------------    32
            Initialising parameters     --------------------------    32
            Reserved registers          --------------------------    33
            Cross Compile               --------------------------    33
            Operating pointers          --------------------------    34
            Segmentation words          --------------------------    35
    15. META or CROSS-COMPILE MODE -------------------------------    35
    16. ARITHMETIC        ----------------------------------------    37
    17. COMPARISONS       ----------------------------------------    38
    18. LOGIC             ----------------------------------------    38
    19. Double precision  ----------------------------------------    40
    20. floating point    ----------------------------------------    41
    21. Transcendental Functions    ------------------------------    41
    23. USER SYST COMMANDS          ------------------------------    42
    24. debugging words             ------------------------------    44
    25. SCREEN CONTROL              ------------------------------    49
    26. CHARACTER INPUT             ------------------------------    51
    27. CHARACTER OUTPUT            ------------------------------    52
    28. NUMBER OUTPUT               ------------------------------    52
    29. NUMBER FORMATTING           ------------------------------    53
    30. file access words           ------------------------------    54
    31. DOS and BIOS access words   ------------------------------    58
    32. CGA and EGA graphics        ------------------------------    60
    33. WINDOW AND TUTORIAL         ------------------------------    63






    4th_86 version 4.02            GLOSSARY                   page  2
    
    -
          ** NOTE ** there is no difference between upper and lower case.
    Some of the words below are in upper in the dictionary -- some in lower
    -- this just depends on how they were defined. The system recognises
    upper and lower case as equivalent when searching the dictionary.

    ==============================================
       ==================
    1. Stack manipulation
       ==================

    OVER   copy NOS over the TOS            b a => b a b

    DROP   remove TOS               b a => b

    DUP    Duplicate the TOS                b a => b a a

    ?DUP   Duplicate the  TOS if and only if the TOS is non-zero.

                                    3 4 => 3 4 4
                                    3 0 => 3 0

    SWAP   Exchange TOS with NOS            3 4 => 4 3

    BSWAP  Swap the bytes in the word at TOS

                                    3456H => 5634H

    PICK    Copy the TOSth element of the stack to TOS. The TOS is
               not counted as part of the stack.

               examples (all values in hex)
                  43 55 12 3e 4  =>  43 55 12 3e 43
                  43 55 12 3e 3  =>  43 55 12 3e 55
                  43 55 12 3e 2  =>  43 55 12 3e 12
                  43 55 12 3e 1  =>  43 55 12 3e 3e

           Note that 1 PICK is equivalent to DUP
                     2 PICK is equivalent to  OVER

    POKE    Move the NOS into the TOSth place. The TOS and NOS are
               not included in the poke count

               examples (all values in hex)
                  43 55 12 3e 3  =>  3e 55 12
                  43 55 12 3e 2  =>  43 3e 12
                  43 55 12 3e 1  =>  43 55 3e
                  43 55 12 3e 0  =>  43 55 12

           Note that 1 POKE is equivalent to SWAP DROP and
              0 POKE is equivalent to DROP






    4th_86 version 4.02            GLOSSARY                   page  3
    
    KILL    Drop n elements from the stack where n = TOS

              examples
                43 55 12 34 2 => 43 55

    ROT     Rotate the top three stack elements

            a  b  c  => b  c  a

    XTRCT   Removes the TOS called n and extracts (moves) the
               stack element indexed by n to the TOS

        example      1 2 3 4 5 1  =>  1 2 3 4 5
                     1 2 3 4 5 2  =>  1 2 3 5 4
                     1 2 3 4 5 3  =>  1 2 4 5 3
                     1 2 3 4 5 4  =>  1 3 4 5 2
                     1 2 3 4 5 5  =>  2 3 4 5 1

           note that 1 XTRCT is equivalent to NOP
              2 XTRCT is equivalent to SWAP
              3 XTRCT is equivalent to ROT

    INSRT   Removes the TOS, called n, and removes the NOS,
               called x. The resultant stack contains two less stack
               elements. x is inserted into the stack indexed by n.

        examples      1 2 3 4 5 1 => 1 2 3 4 5
                      1 2 3 4 5 2 => 1 2 3 5 4
                      1 2 3 4 5 3 => 1 2 5 3 4
                      1 2 3 4 5 4 => 1 5 2 3 4

        note that 1 INSRT => NOP  => 1 XTRCT
                  2 INSRT => SWAP => 2 XTRCT


    DUP@
           Equivalent to DUP followed by @

    DUPB@
           Equivalent to DUP followed by B@

    2DUP@  2DUPB@  3DUP@  3DUPB@

           As for DUP@ and DUPB@ but data from and address in different segment






    4th_86 version 4.02            GLOSSARY                   page  4
    

       ============
     2. return stack
       ============

           ** NOTE ** the 4th_86 program counter is carried in register SI
            the 4th_86 control stack pointer is carried in register DI
            the 4th_86 main stack pointer is carried in register SP


    >R     Push TOS of main stack onto TOS of control stack

    R>     Pop TOS of control stack on tyo TOS of main stack

    R@     Not implemented -- use  0 CSPICK

    CSPICK
           Fetches to the TOS the nth entry in the control stack where
           n is specified by the TOS on entry.

           It behaves in the same way as PICK except that the data is
           picked from the control stack -- and copied on to the main
           stack.

    PSHDI  Assembly routine [ terminates in RET ] that Pushes the 4th_86
           program counter on to the control stack. Typically it is used
           to save the 4th_86 PC as a return address whenever a word
           completes execution and control is transferred to another word.

    POPDI  Assemby routine that Removes the two byte value from the top of
           the control stack and places the value into SI -- the 4th_86
           program counter register. Typically used to restore the 4th_86
           PC when a word completes execution and control is returned to
           the previous word that was executing.

    CSP@

       Return the value of the Control Stack Pointer ( carried in
       register DI

    CSP!

      Store the value on TOS in register DI (Control Stack Pointer)

    PSHDI  Assembly routine [ terminates in RET ] that Pushes the 4th_86
           program counter on to the control stack. Typically it is used
           to save the 4th_86 PC as a return address whenever a word
           completes execution and control is transferred to another word.






    4th_86 version 4.02            GLOSSARY                   page  5
    

    POPDI  Assemby routine that Removes the two byte value from the top
    of
           the control stack and places the value into SI -- the 4th_86
           program counter register. Typically used to restore the 4th_86
           PC when a word completes execution and control is returned to
           the previous word that was executing.


       =====
    3. memory
       =====

    @  ( fetch )

         Fetch to the TOS the byte value whose address is on the TOS

    B@ (byte fetch)

         Fetch to the TOS the byte value whose address is on the TOS

           example   assuming we have a word value 2435 Hex stored at
        address 3705 Hex  --- then

                 3705H B@  will return 35 Hex on the TOS
                                   ( ie the low byte of the word 2435)

    2@  3@  2B@ 3B@ 4b@

        Action identical to @ and b@ -- but in a different segment

    ! ( store )

         Store NOS at address on TOS

    +! (plus store)

         Add NOS to contents of address at TOS and store at the
        same address.

        example   5  534EH  +!  will add 5 to the value
                                    stored at address  534EH

    2! 3! 2B! 3B! 4b!  2+!

        Action identical to ! b! and +! -- but in a different segment






    4th_86 version 4.02            GLOSSARY                   page  6
    
    B! (byte store)

         Stores low byte of NOS as one byte at address on TOS

           example   00EFH  534EH  B!   will store the byte value EF
                      Hex at the address 534E Hex

    MOVE (data move)

         Move the number of bytes on the TOS to the address on
        NOS from the address on 3OS. If the source and destination
        overlap, data will be over-written and lost.

           example   C000H E000H 20H MOVE

            will move 20H bytes from starting address C000H
                                             to address E000H

    2MOVE

         Same as MOVE but source is in base segment and destination is
         in directory segment.

    3MOVE

         Same as MOVE but source is in base segment and destination is
         in cross-compile segment.

    FILL

         Fills memory starting at the address on TOS for a
        count of NOS with the value at 3OS.

          example     11H 20H 8000H FILL

            will fill memory from 8000H through 801FH
                    with the value 11H

    FMEM

         Similar to FILL, but uses an end address instead of a
        count value.

        Fills memory starting at the address on TOS and ending at the
        adress on  NOS with the value at 3OS.

            example    11H 8020H 8000H FMEM

            will fill memory from 8000H through 801FH
                    with the value 11H






    4th_86 version 4.02            GLOSSARY                   page  7
    
       ================
     4. string operators
       ================

    $! (string store)

         Moves the string from base segment source address [ on NOS ] to
            base segment destination address [ on TOS ]

    2$!

           As for $! but move is from base segment to dictionary segment

    3$!

           As for $! but move is from base segment to cross-compile segment

    1$!

           As for $! but move is from dictionary segment to base segment.
           This in fact is the reverse of 2$!

    " ( quoted string processor )

         Fetches the quoted string in the input stream. If the
        system is in high mode then the string is stored in the definition
        being compiled. If the system is in low mode, then the string is
        stored in STRING and the address is returned on TOS.

    ." (dot-quote)  [ synonym of PUTLIN ]

         Writes a string of characters to the console device.
        The TOS contains the [ base segment ] address of the string.
        The first byte of the string contains the length of the string.

        Note that defining the string by " ...string.." automatically
        leaves the address of the string on the TOS.

        If the system is in high mode (ie compile) then the string is
        stored in the definition being compiled. If the system is in
        low mode (ie execute) then the string is stored in STRING and
        its address is retorned on TOS.

    PUTLIN

           Synonym for ."

    2PUTLIN

        As for ." -- but the string is in the dictionary segment. Used
        mainly by debugging words which print out dictionary information.






    4th_86 version 4.02            GLOSSARY                   page  8
    
    STRCAT

         to concatenate two strings. The strings must be defined as
         data constructs -- and space must be left at the end of the first
         string for the added characters being concatenated.

             The format is  Addr1  Addr2  STRCMP with the result at Addr1

        Example:
                data[ " this is " , "           " ] string1
                                data[ " a test  " ] string2

                   string1 string2 strcat
                                             string1   ."

           Note that

                data[ " this is              " ] string1

           is not permissible because string length bytes are involved.

    STRCMP

         to compare two strings for a specified number of bytes.
           Returns 0 for mis-match and 1 for match

       The format is  Addr1  Addr2  Count  STRCMP

        Note --- : FRED " abcdef"  " abcde" 3 STRCMP ;

            will give a mis-match because the first byte of each string
            is the string-length byte. String one is 6 bytes long
            whereas string two  is 5 bytes.

                 : FRED " abcdef" 1+ " abcde" 1+ 3 STRCMP ;
            will step over the count byte, and give a match.

    STRING
           returns the buffer address where a string is stored in LOW mode.
           Only one string can be stored at any time.

            Has no meaning in HIGH mode where all strings are compiled into
            their relevant definition






    4th_86 version 4.02            GLOSSARY                   page  9
    

       =================
    5. structure control
       =================

        ( graphics character 0B3 Hex )

          Can be used in 4th_86 source files which are FLOADed as a
         comment character. It is ignored by 4th_86 ( actually converted to a
         space 20 Hex.)  The intended application is at the left margin to
         format the display of
                            IF
                              IF
                               
                              ELSE
                               
                              THEN
                             
                            THEN

    RETURN

         Provides an immediate exit from a high level definition.
        It can be used anywhere in a word except within a DO .. LOOP
        construct. When executed it is similar to encountering the word
        ;                   ( see also EXIT )

    EXIT

         Provides an abnormal exit from a DO .. LOOP or
        DO .. +LOOP structure. When executed, the flow of control will
        be transferred to the statement imediately following LOOP or
        +LOOP.  ( see also RETURN )






    4th_86 version 4.02            GLOSSARY                   page  10
    

            General comparison techniques
            ==============================

           4th_86 goes beyond the mere comparison of specific digits or
         characters to include both strings and ranges of values.

         This is implemented by words such as
            IF[ ... ]
            OF[ ... ]
            END[ ... ]
                            which are illustrated below

         The ... can include

            an array of integers   2 4 6 "A" "B" 9
            an array of strings    " Hi"   " Hello"
            a range of integers    2 thru 7   "C" thru "L"
            or a mixture         2   4 thru 6  "X" thru "Z"  33H

         Note that "Z" is not the same as " Z".

           The former pushes the ascii value of upper case "Z" on the stack
            The latter is an ascii string

            "Z"        .C
            " Z"       ."
            " Z is part of this ascii string " ."

            Loop control
            ============

    BEGIN ... END

         Provides loop control over the execution of the code
        between the BEGIN and END. The code is executed repeatedly
        until the TOS has a true value when the END is executed. Note
        that the code is always executed at least one time.
                                                   (  see alse END[  )
        example  : print_ten
                   0           ( initialise loop counter)
                   begin
                     1+ dup .  ( increment counter and print it)
                     dup 10 =  ( TOS=1 ( true) if done )
                   end
                   drop        ( loop counter)
                 ;






    4th_86 version 4.02            GLOSSARY                   page  11
    

    END[ (end left bracket)

         Used instead of END in BEGIN .. END construct.
        Instead of using the TOS as a boolean value like END this
        uses the TOS to compare against the list between END[ and its
        matching ]        If the TOS matches any of the values in the
        brackets, then a true condition exists and the loop is exited.

          example   Given the address of text on TOS, search for the
                    first occurrence of an alphanumeric character "A"
        through "Z". "0" through "9"

            : FINDAN  ( find first occurrence of alphanumeric)
                BEGIN
                 1+ ( bump pointer)
                 DUPB@  ( get character)
                END[ "A" THRU "Z"  "0" THRU "9" ]
            ;

    RECURSE

        Purpose: Allows a word being defined to thread back to its own
        definition.

                    : SERIES 5 > if dup . 1- recurse else drop then ;

        The command 123 SERIES  will print the numbers from 123 down through 6

            Note that the following will not work

                    : SERIES 5 > if dup . 1- recurse then drop ;

        because EVERY recursive execution of SERIES results in DROP being
       executed -- producing stack underflow. We only require DROP executed once.






    4th_86 version 4.02            GLOSSARY                   page  12
    

    REPEAT .. WHILE .. ENDWHILE

         Provides loop control over the code between REPEAT and
        ENDWHILE. The code following the ENDWHILE is executed when the
        WHILE is executed and the TOS is false, otherwise the code
        between the REPEAT .. ENDWHILE will be executed.

        The construct is the same as the BEGIN .. END structure except
        that the exit test is made at the top of the loop instead of
        the bottom of the loop.

           example

             data[ 2 4 6 8 10 0 ] table_data

             : PRTABLE
                    repeat
                            dup@ dup
                    while
                            crlf . 2+
                    endwhile
                            2 kill
           ;

           the command table_data prtable will print the data in a column

            Iterative loop control
            ======================

    DO .... LOOP  ( or +LOOP )

         Provides iterative loop control over the code between
        the DO and the LOOP. The structure may be nested up to three
        levels.

           : step_one  20 0 do I . loop ;

            : step_five 20 0 do I . 5 +LOOP ;






    4th_86 version 4.02            GLOSSARY                   page  13
    

    I  J  or  K

        Provides access to the loop counters in either a DO .... LOOP or a
        DO .... +LOOP structure. I returns the counter value of the innermost
        structure.

           Run the following to get a formatted display of loop counters,

           : more     crlf " more? " ." getchr drop crlf ;

           : tabspace tab 2 spcs ;

           : NESTED
                 1 0 do crlf             " level 1 " ."
                                 " I= "     ."      tab i .

                     3 2 do crlf         " level 2 " ."
                                 " I,J = "  ."      tabspace i . j .

                         5 4 do crlf     " level 3 " ."
                                 " I,J,K = " ."     tab i . j . k .

                             7 6 do crlf " level 4 " ."
                                 " I,J,K,? = " ."   tab tab i . j . k .
                             loop
                         loop
                     loop more
                loop

           ;

            Forth Conditional execution
            ===========================

    IF .. ELSE .. THEN

         Provides conditional execution of the code between IF
        and ELSE or ELSE and THEN.

            example

           : test_digit

            5 > if
                    " number is greater than 5 " ."
                else
                    " number is not greater than 5 " ."
                then
                    crlf " test is completed "
           ;






    4th_86 version 4.02            GLOSSARY                   page  14
    
    IF[
         Used instead of IF in IF .. THEN or IF .. ELSE .. THEN
        constructs. Similar in concept to END[  and OF[

            example

           : tdig
            dup . ( print number -- then decide what range it lies in )
               dup ( to retain value for second if[ statement )

                if[ 7 thru 10 ]
                    "   lies between 7 and 10 " ."
                 else
                       dup ( againretain value for possible future use )
                    if[ 3 thru 6 ]
                          "   lies between 3 and 6 " ."
                       else
                            "   does not lie in range 3 thru 10 " ."
                       then
                  then drop crlf
           ;






    4th_86 version 4.02            GLOSSARY                   page  15
    

    CASE .. ENDCASE      OF .. ENDOF

         Provides for selected code to be executed based on the
        contents of TOS. The construct CASE .. ENDCASE defines the
        scope of the case statement. The construcet OF .. ENDOF is used
        inside the CASE .. ENDCASE to define the code to be executed if
        the NOS equals the TOS.

        If NOS = TOS then both values are removed and the code between
        OF .. ENDOF is executed. and control then passes to the code
        following ENDCASE.

        If NOS is not equal to TOS then TOS is removed and control
        continues following ENDOF -- which usually is another OF ..
        ENDOF construct.

        See also the words  OF[ .. ]   and  THRU

        example

           : tdig
            dup . ( print number -- but retain value for CASE test )

            case
                of[ 7 thru 10 ]
                    "   lies between 7 and 10 " ."
                                                    endof
                of[ 3 thru 6 ]
                    "   lies between 3 and 6 " ."
                                                    endof
                    "   does not lie in range 3 thru 10 " ."
            endcase
                   crlf drop
           ;






    4th_86 version 4.02            GLOSSARY                   page  16
    

    OF[
         Used instead of OF in the construct OF ... ENDOF construct.
          Similar in concept to END[  and IF[

           example

           : tdig
            dup . ( print number -- but retain value for CASE test )

            case
                of[ 7 thru 10 ]
                    "   lies between 7 and 10 " ."
                                                    endof
                of[ 3 thru 6 ]
                    "   lies between 3 and 6 " ."
                                                    endof
                    "   does not lie in range 3 thru 10 " ."
            endcase
                   crlf drop
           ;
            Assembly Conditional execution
            ==============================

    |   ( 7C Hex ascii )
         used before a label in CODE definitions.

    LABELS

         Must be the last word used in a code definition -- immediately before
         the terminating semicolon. Needed ** only ** if labels have been used
         in the definition.

           For an example refer to the word CODE. The purpose of LABELS is to
         allow the compiler to include the labels as local variables only -- and
         allow both forward and backward references to be used.






    4th_86 version 4.02            GLOSSARY                   page  17
    

    BEGIN .... ENDZ

         Provides loop control over the ASSEMBLY code between the conditional
         BEGIN and ENDZ.  The code following the conditional END will be executed
         whenever the relevant flag is true.  Otherwise the code between the
         BEGIN and ENDZ is executed.

         Conditional options include

        endo   endno
        enda   endae
        endb   endbe
        endc   endnc  endcxnz
        ende   endne
        endg   endng
        endge  endnge
        endl   endle
        endm   endp
        endna  endnae
        endnb  endnbe
        endnl  endnle
        ends   endns
        endz   endnz
        endpe  endpo


    IFZ .... ELSE .... THEN

         Provides conditional execution of the ASSEMBLY language code
         between the conditional IF and the ELSE ... THEN constructs.
         The code between the conditional IF and ELSE is executed only if the
         relevant conditional flag is true. Otherwise the code between ELSE and
         THEN is executed.

         Conditional opttions include

        ifo   ifno
        ifa   ifae
        ifb   ifbe
        ifc   ifnc  ifcxnz
        ife   ifne
        ifg   ifng
        ifge  ifnge
        ifl   ifle
        ifm   ifp
        ifna  ifnae
        ifnb  ifnbe
        ifnl  ifnle
        ifs   ifns
        ifz   ifnz
        ifpe  ifpo






    4th_86 version 4.02            GLOSSARY                   page  18
    
    REPEAT .... WHILEZ .... ENDWHILE

         Provides loop control over the ASSEMBLY code between the conditional
         WHILE and ENDWHILE. The code following the ENDWHILE will be executed
         whenever the code between the REPEAT .... WHILEZ sets the flags to a
         true condition. Otherwise the code between the WHILEZ and ENDWHILE is
         executed. This structire is similar to the BEGIN .... ENDZ except that
         the exit test is placed at the top of the loop instead of at the bottom
         of the loop.

         Conditional options include

        whileo   whileno
        whilea   whileae
        whileb   whilebe
        whilec   whilenc  whilecxnz
        whilee   whilene
        whileg   whileng
        whilege  whilenge
        whilel   whilele
        whilem   whilep
        whilena  whilenae
        whilenb  whilenbe
        whilenl  whilenle
        whiles   whilens
        whilez   whilenz
        whilepe  whilepo


       ==================
    6. definition headers
       ==================

    : (colon)

         Identifies the beginning of a high level definition. A
        warning message will be given depending on the state of the
        system variable REDEFINE (see later)

    :ENTER (colon enter)

         Allows the user to now use high level (Forth) words if
        currently using low level (assembly) words.

        Acts as a simultaneous header for Forth code and a terminator
        for assembly code.






    4th_86 version 4.02            GLOSSARY                   page  19
    

    :EXIT (colon exit)

         Allows the user to now use low level words (assembly)
        if currently using high level (Forth) words.

        Acts as a simultaneous header for assembly code and a terminator
        for Forth code.

    CODE

         Identifies the beginning of an in-line low level

           code secdelay

                   pop      ax      ( count )
                   mov      bx,0

            mov     bl,al   ( count )
           | tloop
                   mov      ah,2ch  ( get system time )
                   int      21h
            mov     bh,dh   ( seconds )
           | dloop
            int     21h
            cmp     bh,dh   ( has it changed )
            jz      dloop   ( loop if not )
            dec     bl      ( dec count )
            mov     bh,0
            push    bx
            push    bx
                   :enter  dup 9 > if 8 .c then 8 8 .c .c  . :exit
            pop     bx
            cmp     bl,0
            jnz     tloop
           labels
           ;






    4th_86 version 4.02            GLOSSARY                   page  20
    

       ======================
    7. definition terminators
       ======================

    ; (semi-colon)

         Terminates any definition and when executed returns
        control to the threader.

        The words can be either high level (Forth) or low level
        (assembly).


    ;NOTHREAD (semi-nothread)

         Terminates only code definitions and when executed
        does not return control to the threader. Normally used when
        defining assembly language subroutines ending in RET or
        equivalent. ** note ** the RET or equivalent has to be explicitly
        entered in the definition.

        ** note ** if a semicolon was used instead of ;NOTHREAD it would
        insert a JMP THREAD instruction ** after ** the RET. This would cause
        no problems -- other than a JMP THRED instruction that would never get
        executed.


    ;PUSH (semi-push)

         Terminates only code definitions and when executed will push
         the contents of the BX register) onto the TOS and return control
         to the threader.

           It's use is of questionable value -- as the PUSH BX could equally
         be coded in by hand and a semicolon used as terminator.

            code dup

                    mov bp,sp   mov bx,[bp]

             ;push

    :ENTER (colon enter)

         Allows the user to now use high level (Forth) words if
        currently using low level (assembly) words.

        Acts as a simultaneous header for Forth code and a terminator
        for assembly code.






    4th_86 version 4.02            GLOSSARY                   page  21
    

    :EXIT (colon exit)

         Allows the user to now use low level words (assembly)
        if currently using high level (Forth) words.

        Acts as a simultaneous header for assembly code and a terminator
        for Forth code.

       ================
    8. definition flags
       ================

    ASM

         If the word being defined is a code definition
           which is a subroutine with an assembly language return (or
           equivalent), then the word ASM should be used after the
           definition terminator and will cause the dictionary entry
           flags to be set accordingly. This allows the interpreter to
           avoid execution of the flagged word in immediate mode

                    example  CODE FRED ........ RET ;NOTHREAD ASM

             ( see also IMMEDIATE )

    IMMEDIATE

         If the word being defined should not be compiled into
        a definition, but executed whenever detected, then the word
        IMMEDIATE should be used after the definition terminator

           see also ]] and [[






    4th_86 version 4.02            GLOSSARY                   page  22
    

       =================================
    9. variable and constant definitions
       =================================

    BLOCK

         Reserves a block of contiguous memory where the size
        of the block is defined by the value on TOS and the name of the
        block is the next word. When the name of the block is executed,
        the address of the block associated with it is placed on the
        TOS.
             example     Reserve 25 bytes of memory and name it BUFFER

                    25 BLOCK BUFFER

        The address of the buffer is determined automatically at the
        top end of memory. If we assume the address is D912 Hex, then

                   BUFFER .H   will print  D912 on the console

         The words @ b@ ! b! etc are used to access the contents of the
         buffer.

            2 block fred    ( create 2 byte block )

            1234h fred !    ( store word 1234H in block )

            fred @ .h       ( read the content of block and show it )

    CONST

         Defines a single precision constant whose value is on TOS and
         whose name folllows CONST. When the name is executed, the
         value associated with that name is placed on TOS.

            360 CONST circle_degrees
    ,CONST

         Same as CONST - but double precision -- and floating point

            3.1416 ,CONST pi






    4th_86 version 4.02            GLOSSARY                   page  23
    

    DATA[

         Defines a block of memory with the values between "DATA["
         and "]" with the name of the block following  "]"

         The data can either be
            one byte integers
            two byte integers
            strings with a length byte
            strings without a length byte

          To implement the above, certain prefix words exist
            BYTE
            WORD
            LENGTH
            NOLENGTH

           Example
            DATA[ BYTE      145   5394
                  WORD      13
                  LENGTH    " Hi"
                  WORD      423eH
                  NOLENGTH  " Hello" ] table

            : PR_TABLE
                    table dupb@   ( get start of data area on TOS ]
                    dupb@    .    crlf  ( get 145 and display it )
                    1+ ( step over byte )
                    dupb@    .    crlf  ( get 5394 and display it )
                    1+ ( step over byte )
                    dup@     .    crlf  ( get 13 and display it )
                    2+ ( step over word )
                    dup      ."   crlf  ( get " Hi" and display it )
                    dupb@ +         ( add length byte to TOS address )
                    1+ dup@  .H   crlf  ( get 423eH and display it )
                    2+ ( step over word )
                    dup 4 + swap do   ( addr+0 thru addr+4 = 5 characters )
                       I b@ .C   loop       ( dislay 5 character string )
            ;


       ======================
    10. dictionary management
       ======================

    .'
        Print mnemonic of defadr (tos)






    4th_86 version 4.02            GLOSSARY                   page  24
    

    '?

        Find entry in dictionary (tos) that matches defadr (nos)
                   output: tos=address of dictionary entry or
                               0 if not found)
    GTDFA

         Searches the current dictionary for the word following
        GTDFA. If found, the definition address is returned to TOS.

    FIND

         Tries to find a word in a specified dictionary.
        Returns either zero (if the word did not exist in the
        dictionary) or the address of the dictionary entry of the word.
        The TOS contains the address of the dictionary where the search
        is to be started, and the NOS contains the address of the
        string representing the word to find.

    LAST

        A variable that contains the address of the last entry
        in the user dictionary. When a new entry is made in the
        dictionary LAST is decremented by the appropriate amount
        to point to it.

           It is not advisable to write code that specifically
        manipulates the dictionary pointer. Unlike older Forth
        systems the word ALLOT is not needed [ see BLOCK and LUM ]

    DEFINE

         Builds a new entry into the dictionary ( but does NOT
        of itself allow building the code in the definition area)

        The TOS is used as the flag byte. The word being defined
        follows DEFINE. If the word is already in the dictionary, then
        a message is displayed asking whether the word should be
        redefined.

            see manual for fuller details of dictionary structure.

    FORGET

        format FORGET xxxx.  Removes the word xxx from dictionary -- along
        with ALL the words which were defined after it. Code belonging to
        the forgotten words will be over-written as new words are entered.






    4th_86 version 4.02            GLOSSARY                   page  25
    

    OMIT

         To remove unwanted words from the dictionary - either
        for security - or to save space. Normally a file called
        OMITFILE is prepared containing a full list of all the words to
        be omitted.

            The code itself is not removed -- nor any threading from
       other WORDS to the code. Only the dictionary entry is removed.
       The gap created is closed up by moving the remaining dictionary
       entries up.

    LINK

         replaces one definition with another -- provided both
        definitions are already existent.

        example  LINK EGAM CGAM   will cause all references to EGAM to
        instead use CGAM.


    UNLINK

         Removes the latest patch established with LINK. If
        more than one pair of words have been LINKed, only the latest
        one can be UNLINKed. The others are un-recoverable.

    SYNONYM

           Used to define a new word to be equivalent to an existing one.
        No code is generated. A dictionary entry for the new word is
        created and the definition address and the dictionary flags are
        set to the same values as the existing word.

            SYNONYM   ."  PUTLIN

       =============
    11. vocabularies
       =============

           There is no such concept in 4th_86. All dictionaries are threaded
    to each other and transferrence between system dictionary and any user
    dictionaries is transparent. Similarly the relationship between cross-compile
    and system/user dictionary is transparent to the user. Dictionaries have
    their own segment -- and are not "fragmented" by either code or data.

           Only in CROSS-COMPILE mode do two dictionaries co-exist. One for the
    code being cross-compiled -- and the other for the executable system.






    4th_86 version 4.02            GLOSSARY                   page  26
    

        ==========================
    12. Editing and source code
        ===========================

    EDIT

        Purpose: To shell into DOS and run the chosen DOS editor file.
        The file EDITR.BAT must be configured to call your specific DOS editor.
        The file to be used is previously specified with the word USING

           Note that if the command is issued from text mode 3 -- the same
        mode and video page will be returned to on EXIT from DOS.

           If however the command is issued from a graphics mode and page -
        return is not necessarily to the same mode or video page. This is
        because the exit to DOS is into video page 0 - and DOS text will
        over-write; and leave garbage display on graphics page0.

           In the demonstration version -- which uses page0 only -- return
        is always to text mode 3 page 0. In the registered version, an exit
        to DOS will return to the mode it was initiated from -- and if this
        was a video mode, to page 1.

    USING

         Defines the file name to be subsequently used by the
        words EDIT  REDIT  RELOAD.

        Format        USING  < filename>

         If no file name had been specified via the word USING -- then the
        default filename will be EDHELP. This is a text "help" file and not
        a 4th source code file -- hence and any use of RELOAD or REDIT will
        give a load error message.

    RELOAD

         Same function as FLOAD -- but the name of the file to
        be FLOADed does not have to be specified. It is the same name
        which has previously been defined by USING -- ie the same as
        the name used by EDIT and REDIT.

    REDIT

         Equivalent to sequence EDIT  RELOAD ;






    4th_86 version 4.02            GLOSSARY                   page  27
    


        ===============
    13. Compilation
        ===============

            Loading disk files
            ==================
    BLOAD

           Shells to DOS and calls the batch file ASMBL.BAT which then
         calls MASM, LINK, and EXE2BIN in sequence. It will then load the
         BIN file into 4th_86.

           The source file must have a suffix ASM [ eg TEST.ASM ] but the
         command is

                            BLOAD TEST

           Before shelling to DOS the command will check the date of the
         corresponding BIN and ASM files. It will also check the value of
         HEAD against the origin at which any existing BIN file was
         assembled. Only if the BIN file is "out of date" or non existent
         or assembled at the wrong origin will the assembly be executed.

                Note that if the command is issued from text mode 3 -- the same
        mode and video page will be returned to on EXIT from DOS.

           If however the command is issued from a graphics mode and page -
        return is not necessarily to the same mode or video page. This is
        because the exit to DOS is into video page 0 - and DOS text will
        over-write; and leave garbage display on graphics page0.

           In the demonstration version -- which uses page0 only -- return
        is always to text mode 3 page 0. In the registered version, an exit
        to DOS will return to the mode it was initiated from -- and if this
        was a video mode, to page 1.

    FLOAD

        Purpose: To load a Forth source file from disk. Format is

                       FLOAD  FILENAME

        An alternative is  " FILENAME"  LOAD






    4th_86 version 4.02            GLOSSARY                   page  28
    


    ILOAD

        Purpose: To allow a system image saved with ISAVE to be
        reloaded for further work to be done.

        ILOAD will automatically place the sytem in cross compile mode
        before it loads the image file.

        The ILOAD command can not be issued while already in cross
        compile mode. An error message will result.

    LOAD

        An alternative to FLOAD. Whereas we would usually say

           FLOAD filename

        It is possible to achieve the same result by typing

           " filename" LOAD

            Load option switches
            ====================

    IFTRUE .. OTHERWISE .. ENDIF

         A construct for conditionally ignoring segments of
        the input stream. It is an immediate definition and is executed
        when encountered, even in high mode.

         IFTRUE ( evaluate the TOS)
          ....  ( execute or fload this code if TOS is true (non zero))
         OTHERWISE
          ....  ( execute or fload code if TOS is false (zero))
         ENDIF

           The main use is in file-based source code where sections can
         be conditionally loaded or excluded.

    PRINTLOAD

         Controls whether a file being FLOADed is printed at
        the console or not
               OFF PRINTLOAD -- don't show file
                ON PRINTLOAD -- show file as it loads

    PRINTLOC

         Controls whether a file being FLOADed has the compile
        location of each line displayed on the console.






    4th_86 version 4.02            GLOSSARY                   page  29
    
    REDEFINE

         Normally when a definition is created that has the
        same name as another definition, 4th_86 prompts with a warning
        message and queries for continuing or aborting. This featire is
        disabled by the command

                            ON REDEFINE

         and is restored by  OFF REDEFINE

            Compiler control words
            ======================

    HEAD!
         Stores a word in the definition currently being
        defined. The word on TOS is stored at the address in HEAD. The
        contents of HEAD are then incremented by two bytes.

    HEADB!

         Identical to HEAD! but stores a byte value instead of
        a word value, and only increments HEAD by one.

    ' (tick or "defadr")

         Gets the definition address to the TOS of the word
        immediately following ' in the input stream.

    '' (tick-tick or "datadr")

         Gets the contents of the 4th and 5th bytes of the
        definition whose address immediately follows '' in the input
        stream. This is used with the words BLOCK, CONST, etc

            5 BLOCK ABC
              '' ABC .H

        would define the block ABC and then print its actual memor
        address.

           ABC .H

        would also print the actual address of ABC -- but there are
        times (eg in cross-compile) when words such as ABC can not be
        executed per-se and the address has to be found with tick-tick.

        Note that tick-tick is two apostrophes -- not a double quote






    4th_86 version 4.02            GLOSSARY                   page  30
    

    GETLOC

         Fetch to the TOS the address of the next location
        available for entering code into the current definition being
        defined.

    GTDFA

         Searches the current dictionary for the word following
        GTDFA. If found, the definition address is returned to TOS.

    EXEC

         Executes Forth words which may be defined to be
        "immediate" words or entered interactively through the console
        in low mode or execute mode. The TOS contains the address of
        the word to execute.

    ]]
         Changes from compile mode to execute mode.

    [[
         Changes from execute mode back to compile mode

           Normally used within a Forth definition to enclose a fragment
         that is to be executed immediately on load -- as opposed to stored
         in the definition for run-time execution.

           In some ways its equivalent to defining the fragment as an
         IMMEDIATE word.

    [COMPILE]

         Stores the definition address of a word declared to be
        immediate by the word IMMEDIATE into the current definition.

        Format     [COMPILE]  xxxxx    where xxxxx is the word






    4th_86 version 4.02            GLOSSARY                   page  31
    

    DEFINE

         Builds a new entry into the dictionary ( but does NOT
        of itself allow building the code in the definition area)

        The TOS is used as the flag byte. Details of this are

          BIT  HEX   MEANING
           7   80H   WORD WAS USED IN A DEFINITION
           6   40H   -
           5   20H   -
           4   10H   VARIABLE/CONSTANT
           3   08H   MODULE NAME WORD
           2   04H   ASSEMBLY LANGUAGE SUBROUTINE WORD
           1   02H   DO NOT FIND DURING DICTIONARY SEARCH
           0   01H   IMMEDIATE
               00H   NORMAL DEFERRED FORTH DEFINITION

        The word being defined follows DEFINE. If the word is already in
        the dictionary, then a message is displayed asking whether the word
        should be redefined.






    4th_86 version 4.02            GLOSSARY                   page  32
    
    14. system variables
        ================

            System memory configuration
            ===========================

           256K =>++++++++++++++++++++++++++++++++++
                              |  Free for scratch |
                              | ( tutorial text ) | ========> uses 4@ 4! etc
                              |   useage          |           ==============
           192K =>++++++++++++++++++++++++++++++++++
                              |  Free for cross   |
                              |    compile        | ========> uses 3@ 3! etc
                              |      code         |           ==============
                     ES:100H  |   origined 100H   |
           128K =>++++++++++++++++++++++++++++++++++
                              |  reserved space   |
                              |-------------------| <********** SYSLST @
                              |    Relocated      |        = TOPDICT 
         |============>>      | system Dictionary |           = 0FFE0 Hex
         |                    |                   |
         |                    |                   |
         |                    |-------------------| <********** 2LAST @
         |                    |3 bytes dict. link |
         |                    |-------------------| <********* SYSDICT @
         |                    |                   |
         |                    |  User Dictionary  | ========>  uses 2@ 2! etc
         |                    | -grows downwards- |            ==============
         |                    |                   |
         ^                    |!!!!!!!!!!!!!!!!!!!| <********** LAST @ **
        relocated             |vvvvvvvvvvvvvvvvvvv|             grows downwards
         |                    |                   |
         |                    |                   |
         |  64K =>++++++++++++++++++++++++++++++++++
         |                    | system data area  |
    ** INITLUM ============>  |-------------------|
         |          SS:SP =>  |  user data area   |
         |                    |!!!!!!!!!!!!!!!!!!!| <********** LUM @ **
         ^                    |vvvvvvvvvvvvvvvvvvv|             grows downwards
    ** INITHEAD ==>|ooooooooo||                   |
                   |ooooooooo||                   |
        system     |ooooooooo||^^^^^^^^^^^^^^^^^^^|            grows upwards
      dictionary   |ooooooooo||!!!!!!!!!!!!!!!!!!!| <********** HEAD @ **
        in COM     |ooooooooo||  User code area   |
         file      |ooooooooo||  for new 4th &    | ========>   uses  @  ! etc
                   |ooooooooo|| ASM  definitions  |             ==============
                   |ooooooooo||  -grows upwards-  |
    ** SYSLAST  ==>  ======>  |-------------------|
                              |                   |
                              |     System        |
                              |       Code        |
                    CS:100H-> |-------------------|






    4th_86 version 4.02            GLOSSARY                   page  33
    
            Initialising parameters
            =======================
    INITHEAD
    INITLUM
    SYSLAST

           Constants stored in executable COM file to allow initial
           values of HEAD LUM and LAST to be set up when system is
           initiated.

           See above memory map diagram. Note that once the dictionary
           area of the COM file is relocated to segment 2, this area
            becomes free for use of user code -- and HEAD is set to
            SYSLAST accordingly.

            Reserved registers
            ==================

            SI is 4th program counter.  DI is 4th control stack pointer
            ES: = CS: in non cross-compile mode. SS: = base segment always
            CS: = base segment in this version -- will adjust to various
                  code segments automatically in the next version.
            DS: adjusts automatically to meet dictionary vs code needs.

    CSP@

       Return the value of the Control Stack Pointer ( carried in
       register DI

    CSP!

      Store the value on TOS in register DI (Control Stack Pointer)

    SP@

       Fetches to TOS the current pointer of the data stack

    DSPOP

       Pop TOS into register DI

    ESPOP

       Pop TOS into register ES

    ESPUSH

       Push register ES on to TOS

    CSPUSH

       Push register CS on to TOS






    4th_86 version 4.02            GLOSSARY                   page  34
    
            Cross Compile
            =============
    OLDHEAD
    OLDLUM
    OLDLAST

           When cross compile mode is entered, the existing values of
           HEAD LUM and LAST are stored in OLDHEAD OLDLUM AND OLDLAST.

           HEAD LUM and LAST then assume values appropriate to the cross
            compile configuration.

            When cross-compile mode is exited, the original values as
            retained in OLDHEAD OLDLAST and OLDLUM are restored.

    NEWHEAD
    NEWLUM
    NEWLAST

           When cross-compile mode is exited, the existing [ cross
            compile mode ] values of HEAD LUM and LAST are first stored
           in NEWHEAD NEWLUM and NEWLAST. Then the original values as
            retained in OLDHEAD OLDLAST and OLDLUM are restored to HEAD
            LUM and LAST.

           The purpose of retaining the cross-compile values is to
           enable cross-compile mode to be re-entered without loss of
            data or code by using the word RECROSS.

    CROSS
           Flag that indicates whether system is in cross-compile or
           normal mode.

    HISEG
           Flag that indicates to data transfer words whether high segment
            [ segment 3 ] or base segment is involved.

           This may or may not vary in empathy with the variable CROSS

            Operating pointers
            ==================
    HEAD

        Contains the address of the next position of entry into
        the definition area. As each entry is entered into a
        definition, HEAD is incremented by the appropriate amount
        to point to the next address available for entry.






    4th_86 version 4.02            GLOSSARY                   page  35
    

    LAST

        A variable that contains the address of the last entry
        in the user dictionary. When a new entry is made in the
        dictionary LAST is decremented by the appropriate amount
        to point to it.

    LUM

        A system variable which keeps track of a pointer to the data
        storage area. As words like BLOCK and CONST are used, memory storage
        is allocated automatically and the pointer stored in LUM decreases.


            Segmentation words
            ==================

    BASESEG

           Variable that contains the segment address of the 4th_86
           "base segment" executable code

    1SET
           Sets the contents of [baseseg] into DS: register

    DICTSEG

           Variable that contains the segment address of the 4th_86
           "2nd segment" dictionary headers

    2SET
           Sets the contents of [dictseg] into DS: register

    XSEG

           Variable that contains the segment address of the 4th_86
           "3rd segment" cross compile buffer area



    15. META or CROSS-COMPILE MODE
    ==================================






    4th_86 version 4.02            GLOSSARY                   page  36
    

    CROSS-COMPILE

         All user definitions following CROSS-COMPILE are
        marked so that the new definitions may be save using the word
        SAVE. On the TOS is the address-offset of the highest RAM
        location to be used. The NOS is the address of where the code
        should start.

        Only COM files can be handled -- not EXE -- hence the start
        address would normally be 100 Hex.

    RECROSS

        Purpose: Allows cross-compile mode to be re-entered after it has
        been exited by using UNCROSS.

        None of the previously cross-compiled code or data will be lost
        on re-entry **unless** additional definitions have been entered.
        These will over-write the dictionary contents that lie between
        NEWLAST and the exited value of LAST.

    ILOAD

        Purpose: To allow a system image saved with ISAVE to be
        reloaded for further work to be done at a later date.

        ILOAD will automatically place the sytem in cross compile mode
        before it loads the image file.

        The ILOAD command can not be issued while already in cross
        compile mode. An error message will result.

    ISAVE

        Purpose: To allow the current state of a partially meta-compiled
          system to be saved under a specified name xxxx

             ==> use  ISAVE xxxx

        Normally image files are given the suffix xxx.IMG. Both code and
        dictionary are saved -- along with the necessary values of HEAD
        LAST and LUM to allow them to be restored when ILOAD is used.

        ISAVE always saves code starting from 100 H, butit is not
        usually executable [ as per a COM file ] because it lacks the
        necessary boot and initialisation pre-code -- and is probably
        only a small segment of the total needed. It is a useful way of
        storing KERNEL code and loads a lot faster than would the
        original 4th or ASM source code.






    4th_86 version 4.02            GLOSSARY                   page  37
    
        ========
    16. ARITHMETIC
        ========

         *** where TOS and NOS are used - they refer to the value stored at
    these locations -- not to the stack pointer address ****

         *** refer also to the word DZINST to avoid crashing out of 4th_86 via
    the infamous "divide by zero error" **

    +      remove NOS and TOS and replace TOS with NOS + TOS

    -      remove NOS and TOS and replace TOS with NOS - TOS

    *      remove NOS and TOS and replace TOS with NOS * TOS

    /      remove NOS and TOS and replace TOS with NOS / TOS

    /MOD   divide NOS by TOS and leave quotient as TOS and remainder as NOS

           examples   45   3  =>  0  15
               92  11  =>  4   8
               16  32  =>  16  0

    */     multiply 3OS by NOS and divide by TOS using 32 bits for the product

           examples  500 600 30 => 10000
             2000  70 70 =>  2000

    1+     add 1 to TOS

    1-     subtract 1 from TOS

    2+     add 2 to TOS

    ABS (absolute value of)

         Get the absolute value of the TOS

                If the TOS is a signed negative number then its
        positive value will be returned.

         example    FFFF Hex  =>  0001 Hex
                    7FFF Hex  =>  7FFF Hex

    -1*    replace TOS with its 2's complement

          examples   FF Hex  =>  FF01 Hex
                      0 Hex  =>     0 Hex
                      2 Hex  =>  FFFE Hex
                   FFFF Hex  =>  0001 Hex
                     -2       =>   2






    4th_86 version 4.02            GLOSSARY                   page  38
    
    ========
    17. COMPARISONS
    ========

           *** remember test is for signed numbers ***
            *** Returns 0 for FALSE and 1 for TRUE  ***


    =      test if NOS is equal to TOS

    <      test if NOS is less than TOS

    >      test if NOS is greater than TOS

    >=     test if NOS is greater than or equal to TOS

    0=     test if TOS is equal to 0

    U>     test if NOS is unsigned greater than TOS

    0> (positive)

         Test if TOS is greater than zero.

        Returns 0 (false) if TOS is less than or equal to zero.

        Note that 0< is not implemented as such. It can be simulated
        with 0> and 0=
                        : 0<  0>  0=  ;

    ========
    18. LOGIC
    ========

    <-L (rightshift logical)

         Logical shift left the value at NOS by the number of
        bytes on TOS

    ->L (rightshift logical)

         Logical shift right the value at NOS by the number of
        bytes on TOS






    4th_86 version 4.02            GLOSSARY                   page  39
    

    AND  OR  XOR

       These words are interpreted differently depending on whether they are
    being used in an in-line assembly context -- or in a Forth colon definition.

       The user need not worry about the difference. An illustration would be

                : lower_case 5fh and ;
             code lower_case pop ax  and ax,5fh  push ax ;

    -AND -OR -XOR

        These words are explicitly for use in Forth colon definitions. They can
    not be used in an assembly context.

    /AND /OR /XOR

        These words are explicitly for use in CODE assembly definitions. They can
    not be used in a Forth colon context.

    SHR8

         Move the high byte of TOS to the low byte

    SHL8

         Move the low byte of TOS to the high byte






    4th_86 version 4.02            GLOSSARY                   page  40
    

        ====================
    19. Double precision
        ====================

           These are not described individually. The double precision
         ,BLOCK has already been defined. The following double precision
         words are implemented and behave exactly as for the single
         precision equivalents.

      ,AND  ,OR     ,XOR    ,ABS    ,@      ,!      ,*      ,*/     ,2*

      ,2/  ,/       ,/MOD   ,+      ,-      ,-1*    ,OVER   ,DROP   ,DUP

      ,SWAP ,0=     ,0>     ,<      ,=      ,>      ,>=     ,.      ,.H


      The words DOUBLE and SINGLE allow for conversion from single to double
      and from double to single respectively

      Just as
            23H .H

                    will place a single precision value of 23 Hex
      on the stack and then display it -- so similarly will

            ,3H  ,.H do the same but with double precision.


      Likewise         ,2  3  double  ,+   will leave 5 on the TOS in
        double precision.






    4th_86 version 4.02            GLOSSARY                   page  41
    

        ==============
    20. floating point
        ==============

           For a complete description of the floating point implementation,
       see the file FPOINT.DOC

           Floating point values are stored in the same way as double
        precision values. Double precision stack manipulation words such
        as ,DUP can be used with floating point values therefore.

           The data storage format is different however -- so to do
        arithmetic and display values, specific floating point words
        exist

        F*  F+      F-      F-1*    F.      F/      F<

        F=  F>      FABS


      The words FLOAT  and INTEGER allow for conversion from integer to
      float and vice versa.

    PI

       A constant which puts the floating point value of PI on TOS.


    PI/2

       A constant which puts the floating point value of PI/2 on TOS.



        ===========================
    21. Transcendental Functions
        ============================

           For a complete description of the implementation of
       transcendental functions, see the file TRANSCEN.DOC






    4th_86 version 4.02            GLOSSARY                   page  42
    

    22. command line interpreter words
    ==============================

    ERMSG

         Provides a common exit back to the command line interpreter
         whenever an error is detected.

        When executed, TOS contains the number of addresses on the
        stack which point to strings containing parts of an error
        message. The addresses should be placed on the stack such that
        the first message to be printed is deeper into the stack.

           " This is "   " an error message "  2 ermsg

    T37 GETCLI

        Returns the tail of the command line that invoked a 4th_86
        program. The TOS contains the address of a 128 byte buffer
        which will receive the command line. When GETCLI is executed,
        the command line will be moved into the buffer with the first
        byte containing the length of the text read from the command
        line.

    FIND

         Tries to find a word in a specified dictionary.
        Returns either zero (if the word did not exist in the
        dictionary) or the address of the dictionary entry of the word.
        The TOS contains the address of the dictionary where the search
        is to be started, and the NOS contains the address of the
        string representing the word to find.

    ========
    23. USER SYST COMMANDS
    ========

    FILES

        Displays a table of file handles and names with indications of
        those that are open and closed.

    STATUS

        Purpose: Provides the user information concerning the space
        available in the dictionary and the definition tables. If in
        cross mode, the code and data start and stop addresses are also
        displayed






    4th_86 version 4.02            GLOSSARY                   page  43
    

    SYS

        Purpose: Causes the user to shell out to DOS. Return to 4th_86 is
        achieved by typing EXIT (not a Forth word -- a DOS command)

           Note that if the command is issued from text mode 3 -- the same
        mode and video page will be returned to on EXIT from DOS.

           If however the command is issued from a graphics mode and page -
        return is not necessarily to the same mode or video page. This is
        because the exit to DOS is into video page 0 - and DOS text will
        over-write; and leave garbage display on graphics page0.

           In the demonstration version -- which uses page0 only -- return
        is always to text mode 3 page 0. In the registered version, an exit
        to DOS will return to the mode it was initiated from -- and if this
        was a video mode, to page 1.

    SAVESYS

        Purpose: To allow the current state of the running 4th_86 --
        including all new words loaded -- to be saved under the name
        4th--86.COM. (see also FSAVE)

            No parameters needed --- just type SAVESYS at any time. Any
         existing 4th--86.COM will be over-written.

    SETMEM

         To set the amount of memory reserved for 4th_86 to operate in.
         Normally set to 4 64K segments on initialisation by

                       4000H SETMEM

    BRKOFF

        Disables the control-break function of DOS by redirecting the
        ctrl-brk interrupt vector to an IRET. The original vectored
        address is saved for restoring with BRKON. Gives error message
        if BRKOFF is already in effect.
            BRKOFF is normally implemented on initialisation of 4th_86.

    BRKON

        Makes the ctrl-brk key functional so that endless loops can be
        exited. Dumps the user back to DOS however.






    4th_86 version 4.02            GLOSSARY                   page  44
    

    Q-U-IT

        Not normally used ( BYE is preferred exit method)

        Returns to DOS and closes all files - but does not restore the
        video mode to NORMal text mode.

    BYE
         the normal exit from 4th_86 back to DOS. Closes all files
         and resets the EGA card to normal text mode.

    DZHALTOFF

        Disables the error message normally printed on screen when a divide
        by zero interrupt occurs.

    DZHALTON

        Restores the printing of on screen error messages when a divide
        by zero interrupt occurs.

    DZINST

        Installs a "divide by zero error" handler. Checks to make sure that
        the handler is not already installed -- and stores the information
        needed to restore the original DOS interrupt vector with DZREST.

    DZREST

        Removes the handler previously installed by DZINST and restores the
        original DOS vectoring. Checks to make sure that there actually is
        a 4th_86 handler installed -- and that the data retained by the
        previous DZINST is likely to be valid. It does this by checking the
        segment value of this restoration data with the CS: value of the 4th_86
        system running.


        ===================
    24. debugging words
        ===================






    4th_86 version 4.02            GLOSSARY                   page  45
    


    INT3

        Provided 4th_86 has been entered from within a debugger shell
        [ for example by typing DEBUG 4TH86DEM.COM and then typing G at the
        DEBUG.COM prompt ]; INT3 will exit from 4TH_86 into the debugger
        that was used.

        To return to 4th_86 again -- make sure the CS: and DS: segment
        values have not been altered -- and then start operation at offset
        200H [ the address of THREAD ]. The relevant DEBUG.COM command is
        G=200

        4th_86 contains enough FORTH debugging facilities to make the use
        of a DOS debugger shell un-necessary. It can however be useful for
        stepping through assembly code -- or examining memory over a range
        of segments.

        Note also that unless screen-swapping is implemented; the original
        4th_86 screen display will be lost as you use DEBUG.COM.

    PAT

         Allows one word in a definition to be changed to
        another word. The format is

                    address  PAT  word

        where address is the patch address, and word is the dictionary
        name of the word to store at address.

    PNOP   patches in a NOP

    UNPAT  reverses last PAT or PNOP

    PDICT

         The dictionary entry of a single word is displayed

        example    PDICT  DUP    will display the entry for DUP






    4th_86 version 4.02            GLOSSARY                   page  46
    

    16DM

         Dumps 16 lines of memory starting at the address on
                                      TOS.
                example   8000H DM   will return the following memory
                          dump and will ALSO leave on the TOS the
                          address 8100 Hex ready for another 16DM

            ( see also DM and 8DM)

         8000  01E83281 887B747F 3E01E829 81407C74    *..2..{t.>..).@|t*
         8010  7F3E01E8 CEF50000 0000E8C7 F5000080    *.>..............*
         8020  3FE8C0F5 00000040 E8B9F500 002041E8    *?......@..... A.*
         8030  B2F5CDCC CC3DE8FD 80EF014A 01FF7FBF    *.....=.....J....*
         8040  02EF013E 01E8EE80 6576D002 91015A80    *...>....ev....Z.*
         8050  EF014A01 0080E102 EF013E01 E8D780F8    *..J.......>.....*
         8060  7FCC012D 053E01E8 CC808B76 5C803E01    *...-.>.....v\.>.*
         8070  E871F5FC FFFFFFE8 BC80D175 7080AB75    *.q.........up..u*
         8080  13773E01 5A5B0AC0 B000F512 073C0A73    *.w>.Z[.......<.s*
         8090  03E90200 B0008807 4BFECA74 03E9E8FF    *........K..t....*
         80A0  7303E90B 0043C607 01BA0800 03DAFE07    *s....C..........*
         80B0  E95180E8 80801808 18081808 18083608    *.Q............6.*
         80C0  FA013608 FA011808 3B080802 18084008    *..6.....;.....@.*
         80D0  08026576 3680D002 9101BD81 C4011808    *..ev6...........*
         80E0  FB049101 EE801D08 27080802 36806576    *........'...6.ev*
         80F0  76010000 803FCA76 91010881 2F800180    *v....?.v..../...*

    8DM

         Dumps 9 lines of memory starting at the address on
        TOS. (see 16DM)

    DD (dump definition)

         The word DD decompiles any 4th_86 word -- Forth or ASM.

          example    DD QUIT  will decompile the word QUIT


    DDH

         Decompiles only Forth code -- and must be given a ** valid **
         starting memory address

           eg       1234H DDH

         ** note ** this assumes that address 1234H does in fact contain
         a valid Forth link address.






    4th_86 version 4.02            GLOSSARY                   page  47
    

    DDL

         Decompiles only ASM code -- and must be given a ** valid **
         starting memory address

           eg       200H DDL

         ** note ** this assumes that address 200H does in fact contain
         a valid ASM op code. [ it could be the CALL COLON which starts
         all Forth definitions ]


    TRACEON

           Inserts a trace facility into THREAD so that the stack can be
         continuously monitored as the specified 4th_86 word threads through
         its component words.

           eg        FRED  3 2 * . ;

            TRACEON FRED

          when the word FRED is executed the flow and stack will be displayed.

    TRACEOFF

           Turns off the trace facility enabled by a previous TRACEON command.

    TAG

           Stands for "trace again". In effect reverses a previous TRACEOFF
           command without having to re-specify the word to be traced.


    TRACEL

           Stands for "trace level".

           Normally trace level would be zero -- and the code inside [ for
            example ] DO ... LOOP expressions would not be traced.

           By specifying   3 TRACEL  the level of the trace will be extended
           to include the DO .. LOOP expression.

           If nested DO .. LOOP constructs are involved, TRACEL may need
            to be set to a multiple of 3






    4th_86 version 4.02            GLOSSARY                   page  48
    

    PAT

        Purpose: Allows one word in a definition to be changed to
        another word. The format is

                    address  PAT  word

        where address is the patch address, and word is the dictionary
        name of the word to store at address.


    PATCH

        Purpose: Alters a constant value in the definitions. PATCH uses
        the TOS as the value to patch at the word which follows PATCH

        example   suppose the constant LENGTH was defined with a value
                  of 100, and later a value of 200 was needed.

                        200 PATCH LENGTH   will do this


    PDICT

        Purpose: The dictionary entry of a single word is displayed

        example    PDICT  DUP    will display the entry for DUP


    DDICT (dump dictionary)

         The word DDICT has no arguments and dispalys each dictionary
        entry of all the dictionaries (which are linked to each other).

        see manual for fuller details

    DS
         Displays to the console device all the stack entries
        currently on the stack, in hexadecimal -- and leaves the stack
        unchanged.

        If the stack is empty when DS is executed, then the message
        STACK EMPTY is printed.

        If the stack has underflowed (ie too many entries DROPped),
        then printed on the console is the message:

             STACK UNDERFLOW ... RESETTING STACK.






    4th_86 version 4.02            GLOSSARY                   page  49
    

    DDS (destructive display stack)

         Displays to the console device all the stack entries
        currently on the stack, in hexadecimal -- and leaves the stack
        empty.

        If the stack is empty when DDS is executed, then the message
        STACK EMPTY is printed.

        If the stack has underflowed (ie too many entries DROPped),
        then printed on the console is the message:

             STACK UNDERFLOW ... RESETTING STACK.

    DEBUG

         The word DEBUG toggles the debug facility on and off.
        The debug facility allows the operator to view the stack while
        executing words interactively.


    DEPTH

         Brings to the TOS the total number of entries on the stack

    DM

         Dumps one line of memory starting at the address on
        TOS. (see 16DM)


        ==================
    25. SCREEN CONTROL
        ==================

    CLS
           Clearscreen -- as for equivalent DOS command

    NORM

         Initialise multi-function graphics card in 80x25
        color text mode -- and clear video buffer.
        (see also NEGAM CGAM NCGAM NORM NNORM)

    GETMODE

         Return on TOS the active display page, and on NOS the
        number of columns (high byte) and the display mode (low byte)






    4th_86 version 4.02            GLOSSARY                   page  50
    

    COLORTEXT

         Turns normal screen text display into yellow on a blue
         background.

         The colors can be configured by altering the variable
         stored in GCOLOR

    PLAINTEXT

         Returns normal screen display to white on black background.

    GOTOXY

         To locate the cursor.

               : FRED 12h 11h gotoxy " test" ." ;

       will print the word 'test' at the Hex x,y co-ordinates 12,11

    GETXY

         Returns the x,y co-ordinates of the cursor. TOS is y value and
         NOS is x value.

    GCOLR

        A variable which controls the colour of all characters printed
        with the word GCOUT ( or digits via .CL )


    IVPAGE

        A flag which can be set to enable or disable video page switching.

        If set to zero [ as in the demonstration version of 4th_86 ] then the
        system will always display text in video page 0.

        If set to 1 -- then the PAGE0 and PAGE1 commands can be used -- and
        automatic page switching will take place with words such as BLOAD
        and EDIT.

        If set to 1 -- then 4th_86 itself always displays in page1. Anything
        which effectively shells to DOS will display in video page 0.






    4th_86 version 4.02            GLOSSARY                   page  51
    

    PAGE0

        Switches video display to page 0 of current mode. Will work in both
        text mode 3 and graphics modes 4 or 10, Note that mode must be set
        first with one of NORM, EGAM, or CGAM.

           The Demonstration 4th_86 is configured to work entirely in page0
        as a default.

    PAGE1

        Switches video display to page 1 of current mode. Will work in both
        text mode 3 and graphics modes 4 or 10, Note that mode must be set
        first with one of NORM, EGAM, or CGAM.

           The Demonstration 4th_86 is configured to work entirely in page0
        as a default. The command PAGE1 will have no effect.


    ========
    26. CHARACTER INPUT
    ========

    GETCHR

         When executed the TOS contains the next character
        entered at the console.

    GETLIN

         Returns a line of text entered at the console. The TOS
        contains the address of the buffer which should receive the text
        with the first byte of the buffer containing the maximum length
        of the string to be collected. When GETLIN is executed, the
        second byte of the buffer will contain the actual number of
        bytes read from the console with the text beginning at the
        third byte of the buffer.

    GETSTS

         When executed the TOS contains a 1 if a character was
        detected at the console, or a zero if no chartacter was detected.

        If a character is at the console, GETCHR can be executed to
        fetch the character.






    4th_86 version 4.02            GLOSSARY                   page  52
    

    WORD

         Fetches a word from the input stream and stores it in
        ATOM, returning the address of ATOM on TOS. A word is defined
        in the input stream as ANY sequence of ASCII printable
        characters delineated by at least one space or blank.


    ========
    27. CHARACTER OUTPUT
    ========

    CRLF
         Prints a carriage return and line feed on the console

    .C (dot-see)

         Writes the ASCII character on the TOS to the console
        output device

    .CL (dot-see-el)

         Same as .L but writes numerical value in a colour defined by
         the current contents of GCOLR.

    GCOUT

        Prints ascii character on TOS in colour determined by value on
        variable GCOLR.


    ========
    28. NUMBER OUTPUT
    ========

    . (dot)

         Prints the TOS as a five digit decimal number with a
        leading space

    ,.     prints TOS and NOS as 10 digit decimal number

    F.      prints TOS and NOS as a floating point number

    .B
         Prints the TOS as a binary number of 1's and 0's






    4th_86 version 4.02            GLOSSARY                   page  53
    

    .H (dot-aitch)

         Prints the TOS as a four digit hexadecimal number with
        a leading space.

    ,.H    prints TOS and NOS as 8 digit hex number

    .HB (dot-aitch-bee)

         Prints the TOS as a two digit hexadecimal number with
        a leading space

    .L
          While this prints the TOS as a five digit decimal
        number WITHOUT a leading space -- its purpose is to send ANSI
        control parameters to the screen.

    .Q
         Prints the TOS as an octal number


    ========
    29. NUMBER FORMATTING
    ========

           See also the file SHARPS.4TH

    GVAL (get numeric value)

         Evaluates a character string as a numeric string and
        converts it into a binary number. The TOS on entry is the
        address of the character string. On exit, the TOS is a flag:
        zero - returned value is single precision
        one  - returned value is double precision
          The NOS is the low order two bytes of the double precision,
        or floating point value, and the 3OS is the high order two
        bytes.
          If the value is single precision as denoted by TOS, then 3OS
        must be DROPped.

    NUMBER

         Evaluates a numeric string found in the input stream
        as a binary number and stores it into the current definition.
        The number may be either single or double precision.






    4th_86 version 4.02            GLOSSARY                   page  54
    

    VAL

        Returns on the stack either a single or a double precision value,
        whichever was specified in the input stream. If a single precision value
        is returned, then it is on the TOS. If a double precision value is
        returned, then the low order is returned on the TOS and the high order on
        the NOS.

    30. file access words
        =================

    *** General note

           There are two versions of some words -- for example -- READ
           and SYSREAD. The difference lies in the action taken under error
           conditions. SYSREAD  will not return the error codes listed below.
           It will simply issue an error message and return to the CLI.

           The following code for SYSREAD indicates the behaviour

            : SYSREAD         READ
                                    IF ( some error )
                                         " FILE READ" 1 ERMSG
                                    THEN    ;

            CLOSE does not return any error codes.


    CLOSE

        Closes a file that has previously been opened. The TOS
        contains the file handle number of the file to be closed.
        If all files should be closed then the TOS should contain a zero.
        No error code will be returned.

    FILES

        Displays a table of file handles and names with indications of
        those that are open and closed.

    FSAVE

        Purpose: To allow the current state of the running 4th_86 --
        including all new words loaded -- to be saved under a
        specified name  xxxx  ==> use  FSAVE xxxx ( see also SAVESYS)






    4th_86 version 4.02            GLOSSARY                   page  55
    

    LSEEK

        Sets the file pointer location relative to the start of the file;
        the end of the file; or the current file position. On entry TOS is
        least significant half of offset; NOS is most significant half; 3OS is
        the method code; and 4OS is the file handle.

           On return, TOS is zero for no error -- and the usual DOS error
        code if failed. Refer to DOS Int 21h function 42H for more
        information - but note that LSEEK does not return the new pointer
        location that DOS makes available.

    OPEN

        Opens a file for either input or output. The TOS
        contains a 1 for input or a 2 for output. The NOS contains the
        address of the ASCIIZ filename including any DOS paths, which
        is to be opened. If the file is opened for output, no data can
        be written to it. If the file is opened for
        output, any previous file will be deleted and a new file opened.

           Entry:  TOS = 1 or 0 for Input or Output respectively
                   NOS = address of ASCIIZ filename

           Exit:   Input parameters removed from stack and
                   TOS = error code or 0 for no error
                   NOS = handle allocated by DOS to opened file

           Error codes:   0  -  no error
                          1  -  file not found ( read files only )
                          2  -  path not found or file doesn't exist
                          3  -  no handle available
                   4  -  access denied






    4th_86 version 4.02            GLOSSARY                   page  56
    

    READ

         Inputs data sequentially from a previously opened
        file. The TOS contains the file handle number of the already
        opened file to read from. The NOS contains the
        address of the buffer to read the data into. The 3OS contains
        the maximum number of bytes to read. When the input data has
        been moved into the buffer, or when an error occurs, then the
        TOS contains an error code and the NOS contains the actual
        number of bytes read into the buffer.

           Entry:  TOS = file handle from previous OPEN
                   NOS = address of buffer for read data
                   3OS = max number of bytes to read

           Exit:   Input parameters removed from stack and
                   TOS = error code or 0 for no error
                   NOS = number of bytes actually read

           Error codes:   0  -  no error
                          1  -  read error
                          2  -  not used
                          3  -  file not open or not open for input


    SYSRBYTE

         Reads one byte from a file. The TOS contains the file handle number
        of the already opened file to be read. Upon exit the TOS contains 0 if
        end of file has been reached -- and contains 1 if not end of file. The
        NOS contains the byte read.

    SYSCLOSE

         Closes a file. The TOS contains the file handle number
        of the already opened file to be closed, or zero if all files
        should be closed.

    SYSOPEN

         Opens a file for either input or output. The TOS
        contains the access code (1=input 2=output) and the NOS
        contains the address of the filename which should be opened.
        Upon exit, the TOS contains the DOS file handle number






    4th_86 version 4.02            GLOSSARY                   page  57
    

    SYSREAD

         Reads a block from a file to a buffer. The TOS
        contains the file handle number of the already opened file
        to be read from. The NOS contains the address of the
        buffer to read into. The 3OS contains the number of bytes
       to read. Upon exit  from SYSREAD the TOS contains the actual
       number of bytes read.

    SYSWBYTE

         Writes one byte to a file. The TOS contains the file handle number
        of the already opened file to be written to. The NOS contains the
        byte to be written.

    SYSWRITE

         Writes a block from a buffer to a file. The TOS
        contains the file handle number of the already opened file
        to be written into. The NOS contains the address of
        the buffer to write from. The 3OS contains the number of bytes
        to write.

    2SYSREAD

        Same as SYSREAD - but buffer ( offset ) address is in dictionary
        segment.

    3SYSREAD

        Same as SYSREAD - but buffer ( offset ) address is in cross-compile
        segment.

    2SYSWRITE  2WRITE  2READ

        Dictionary segment equivalents of SYSWRITE  WRITE  READ

    3SYSWRITE  3WRITE  3READ

        Cross-compile segment equivalents of SYSWRITE  WRITE  READ






    4th_86 version 4.02            GLOSSARY                   page  58
    

    WRITE

         Outputs data sequentially to a previously opened
        file. The TOS contains the file handle number of the already
        opened file to write to. The NOS contains the
        address of the buffer to write the data from. The 3OS contains
        the number of bytes to write. When the input data has
        been moved into the buffer, or when an error occurs, then the
        TOS contains an error code.


           Entry:   TOS = file handle from previous OPEN
                    NOS = address of data to write
                    3OS = number of bytes to write

           Exit:    Input parameters removed from stack and
                    TOS = 0 for no error, otherwise error code

           Error Codes:   0 - No error
                          1 - Write error
                          2 - No space available
                          3 - File block not opened for output


    31. DOS and BIOS access words
        =========================

    MON1

         A call is made to the operating system and no value is
        returned. The TOS contains the function code and NOS contains
        any address requirted by the function.

    MON2

         A call is made to the operating system and a value is
        returned on TOS. The stack values on entry are as for MON1

    GETDATE

        Returns the time and date stamp of a previously opened file. On entry
        to GETDATE the TOS must contain the file handle of the opened file. On
        return, the TOS is the date and the NOS is the time. For details of the
        format of the returned values refer to DOS Int 21H function 57H.

    DATE

      Displays the date in Day Month Year format






    4th_86 version 4.02            GLOSSARY                   page  59
    

    DAYTE

      Returns the date month and year as three parameters on the stack

    SECDELAY

        Causes a time delay of xx seconds where xx is the number on TOS. As
        the delay progresses a countdown is displayed on screen.


    TD (time and delay)

         displays the time in hours, minutes, seconds, tenths.
        Also displays the time elapsed since the previous reference to
        TD

    ELAPSED

         Same as TD

    TDLOCK

         TD ( or ELAPSED ) normally displays the elapsed time since the
    immediately prior use of TD. In other words, TD is incremental - and sets the
    internal elapsed time counter to zero every time it completes execution.

         If it is require to display a running series of elapsed times -- each
    with reference to the same "start" point [ ie - not reset the counter ] then
    TDLOCK should be executed immediately prior to *every* use of TD [ or
    ELAPSED].

    TM (time)

         displays the time in hours, minutes, seconds, tenths.

    TIME

         same as TM

    TYME

        Returns the hours minutes and seconds as parameters on the stack


    CD

        Change directory - use as for equivalent DOS comand






    4th_86 version 4.02            GLOSSARY                   page  60
    

    DIR

        Display the directory of current drive

          The format is:

            DIR        or     DIR B: etc

           The current drive can be changed with A:   ---   D:
           The subdirectory can be changed with CD
           Paths are implemented -  DIR C:\FORTH\DOCS

    TYPE (type file)

         To display on the screen the contents of a disk text
        file.

           The format is

                  TYPE  FILENAME    or   TYPE B:\FORTH\FILENAME

           The current drive can be changed with A:   ---   D:



    32. CGA and EGA graphics
        ====================

    FCIRCLE1

        Purpose: Draws a filled circle at centre X Y of radius R and color C

           Input --    X  Y  R  C  <= TOS

        The fill is done by drawing circles of continuously decreasing
        radius.

        Note that the card must be initialised first with either EGAM
        or CGAM.

    FCIRCLE2

        Purpose: Draws a filled circle at centre X Y of radius R and color C

           Input --    X  Y  R  C  <= TOS

        The fill is done by drawing horizontal lines between the boundaries
        of the circumference.

        Note that the card must be initialised first with either EGAM
        or CGAM.






    4th_86 version 4.02            GLOSSARY                   page  61
    
    HLINE

        Purpose: Draws a horizontal line of specified color.
        The format is
                      X1 X2 Y C HLINE

                                     where X1,Y and X2,Y are the end

        co-ordinates and C is the color

    NCGAM

         Initialise multi-function graphics card in 640x200
        2 color CGA graphics mode -- but do NOT clear video buffer.
        (see also NEGAM CGAM EGAM NORM NNORM)

    NEGAM

         Initialise multi-function graphics card in 640x350
        16 color EGA graphics mode -- but do NOT clear video buffer.
        (see also EGAM CGAM NCGAM NORM NNORM)

    NORM

         Initialise multi-function graphics card in 80x25
        color text mode -- and clear video buffer.
        (see also NEGAM CGAM NCGAM NORM NNORM)

    NNORM

         Initialise multi-function graphics card in 80x25
        color text mode -- but do NOT clear video buffer.
        (see also NEGAM CGAM NCGAM NORM NNORM)

    CGAM

         Initialise multi-function graphics card in 640x200
        2 color CGA graphics mode -- and clear video buffer.
        (see also NEGAM EGAM NCGAM NORM NNORM)






    4th_86 version 4.02            GLOSSARY                   page  62
    

    CIRCLE

         Draws a circle at centre X Y of radius R and color C

           Input --    X  Y  R  C  <= TOS

        This is based on an algorithm in July '83 Dobbs Journal. Larger
        circles will be drawn with a coarser dot pattern than will
        smaller circles.

        The aspect ratio is corrected so that a true circle is produced
        in the EGA high-res mode. Other modes may produce a flattened
        circle.

        Note that the card must be initialised first with either EGAM
        or CGAM.

    DBOX

         Draws a filled box. The format is

                      X1 Y1 X2 Y2 C DBOX

             x1,y1  ------------------
                   |                  |
                   |                  |
                   |                  |
                   |                  |
                    ------------------  x2,y2

                                            C is the color

    DLINE

         Draws a line starting from the end of the previous
        line drawn. To move the starting point to a new position, use
        DLINE with a colour value equal to the background colour. The
        format is
                      X Y C DLINE
                                     where X and Y are the end
        co-ordinates and C is the color

    DPIX

         Draws a pixel at the specified co-ordinates
        The format is
                      X Y C DPIX
                                     where X and Y are the
        co-ordinates and C is the color






    4th_86 version 4.02            GLOSSARY                   page  63
    

    D4PIX

         Draws a "nybble" -- 4 consecutive pixels all the same
        color -- at the specified co-ordinates. This is implemented for
        speed of drawing where a coarse pattern is acceptable.

        The format is
                      X Y C D4PIX
                                     where X and Y are the
        co-ordinates and C is the color

    EGAM

         Initialise multi-function graphics card in 640x350
        16 color EGA graphics mode -- and clear video buffer.
        (see also NEGAM CGAM NCGAM NORM NNORM)

    EGANIB (same as D4PIX)

         Draws a "nybble" -- 4 consecutive pixels all the same
        color -- at the specified co-ordinates. This is implemented for
        speed of drawing where a coarse pattern is acceptable.

        The format is
                      X Y C EGANIB
                                     where X and Y are the
               co-ordinates and C is the color

    VLINE

        Purpose: Draws a vertical line of specified color.
        The format is
                      X Y1 Y2 C VLINE

                                     where X,Y1 and X,Y2 are the end

        co-ordinates and C is the color


    33. WINDOW AND TUTORIAL
    ========================

    HELP

        Loads the file TUTORIAL.TXT [ into high memory ] as default, and
        initiates a colored split-screen window tutorial.






    4th_86 version 4.02            GLOSSARY                   page  64
    

    SPLITSCREEN

        Splits the display screen into two colored windows.

    FULLSCREEN

        Undoes the effect of SPLITSCREEN

    UNSPLIT

        Synonym for FULLSCREEN

    SPLITAT

        Controls the Y co-ordinate at which screen splitting occurs.

         use a   SPLITAT N   where N is a value between 0 and 24

        If N is greater than 24 it will be set to 24

        W1 is top section of screen -- W2 is lower

    SPLIT

        Splits the screen at mid point.

           : .cwin  getxy drop ( unwanted X value)

    WIN1

           0 win1 will initialise window
           5 win1 will scroll window up 5 lines **
           xx05 win1 will scroll window down 5 lines
           where xx is any non-zero byte

    WIN2

           As for WIN1

    W1INIT

        Clears window 1. Equivalent to  0 WIN1

    W2INIT

        Clears window 2. Equivalent to  0 WIN2






    4th_86 version 4.02            GLOSSARY                   page  65
    

    W1

        Places 4th_86 prompt and cursor in window 1

    W1

        Places 4th_86 prompt and cursor in window 2

    WINDOW

           Basic assembly language routine to Initialise window or
           scroll it up or down

           Enter parameters in the order of

            scroll-lines
            attribute
            topx
            topy
            botx
            boty            <==== TOS

           If high byte of scroll-lines is zero - scroll is up
           If high byte of scroll-lines is not zero - scroll is down




    !     --------------------------------------------------------     5
    "     --------------------------------------------------------     7
    $!    --------------------------------------------------------     7
    ' (tick or "defadr")        ----------------------------------    29
    '' (tick-tick or "datadr")  ----------------------------------    29
    '?    --------------------------------------------------------    24
    */    --------------------------------------------------------    37
    *     --------------------------------------------------------    37
    +!    --------------------------------------------------------     5
    +     --------------------------------------------------------    37
    ,!    --------------------------------------------------------    40
    ,*/   --------------------------------------------------------    40
    ,*    --------------------------------------------------------    40
    ,+    --------------------------------------------------------    40
    ,-1*  --------------------------------------------------------    40
    ,-    --------------------------------------------------------    40
    ,.H   --------------------------------------------------------    40
    ,.H   --------------------------------------------------------    53
    ,.    --------------------------------------------------------    40
    ,.    --------------------------------------------------------    52
    ,/MOD --------------------------------------------------------    40
    ,/    --------------------------------------------------------    40
    ,0=   --------------------------------------------------------    40






    4th_86 version 4.02            GLOSSARY                   page  66
    
    ,0>     ------------------------------------------------------    40
    ,2*     ------------------------------------------------------    40
    ,2/     ------------------------------------------------------    40
    ,<      ------------------------------------------------------    40
    ,=      ------------------------------------------------------    40
    ,>=     ------------------------------------------------------    40
    ,>      ------------------------------------------------------    40
    ,@      ------------------------------------------------------    40
    ,ABS    ------------------------------------------------------    40
    ,AND    ------------------------------------------------------    40
    ,CONST  ------------------------------------------------------    22
    ,DROP   ------------------------------------------------------    40
    ,DUP    ------------------------------------------------------    40
    ,OR     ------------------------------------------------------    40
    ,OVER   ------------------------------------------------------    40
    ,SWAP   ------------------------------------------------------    40
    ,XOR    ------------------------------------------------------    40
    -1*     ------------------------------------------------------    37
    ->L     ------------------------------------------------------    38
    -AND    ------------------------------------------------------    39
    -OR     ------------------------------------------------------    39
    -XOR    ------------------------------------------------------    39
    -       ------------------------------------------------------    37
    . (dot) ------------------------------------------------------    52
    ."      ------------------------------------------------------     7
    .'      ------------------------------------------------------    23
    .B      ------------------------------------------------------    52
    .C      ------------------------------------------------------    52
    .CL     ------------------------------------------------------    52
    .H (dot-aitch)        ----------------------------------------    53
    .HB (dot-aitch-bee)   ----------------------------------------    53
    .L      -------------------------------------------------------   53
    .Q      -------------------------------------------------------   53
    /AND    -------------------------------------------------------   39
    /MOD    -------------------------------------------------------   37
    /OR     -------------------------------------------------------   39
    /XOR    -------------------------------------------------------   39
    /       -------------------------------------------------------   37
    0=      -------------------------------------------------------   38
    0>      -------------------------------------------------------   38
    1$!     -------------------------------------------------------    7
    1+      -------------------------------------------------------   37
    1-      -------------------------------------------------------   37
    16DM    -------------------------------------------------------   46
    1SET    -------------------------------------------------------   35
    2!      -------------------------------------------------------    5
    2$!     -------------------------------------------------------    7
    2+!     -------------------------------------------------------    5
    2+      -------------------------------------------------------   37
    2@      -------------------------------------------------------    5
    2B!     -------------------------------------------------------    5
    2B@     -------------------------------------------------------    5






    4th_86 version 4.02            GLOSSARY                   page  67
    
    2move      ---------------------------------------------------     6
    2putlin    ---------------------------------------------------     7
    2READ      ---------------------------------------------------    57
    2SET       ---------------------------------------------------    35
    2SYSWRITE  ---------------------------------------------------    57
    2WRITE     ---------------------------------------------------    57
    3!         ---------------------------------------------------     5
    3$!        ---------------------------------------------------     7
    3@         ---------------------------------------------------     5
    3B!        ---------------------------------------------------     5
    3B@        ---------------------------------------------------     5
    3move      ---------------------------------------------------     6
    3READ      ---------------------------------------------------    57
    3SYSREAD   ---------------------------------------------------    57
    3SYSWRITE  ---------------------------------------------------    57
    3WRITE     ---------------------------------------------------    57
    4b!        ---------------------------------------------------     5
    4b@        ---------------------------------------------------     5
    8DM        ---------------------------------------------------    46
    : (colon)  ---------------------------------------------------    18
    :ENTER (colon enter)       -----------------------------------    20
    :ENTER                     -----------------------------------    18
    :EXIT (colon exit)         -----------------------------------    19
    :EXIT (colon exit)         -----------------------------------    21
    ; (semi-colon)             -----------------------------------    20
    ;NOTHREAD (semi-nothread)  -----------------------------------    20
    ;PUSH (semi-push)          -----------------------------------    20
    <-L      -----------------------------------------------------    38
    <        -----------------------------------------------------    38
    =        -----------------------------------------------------    38
    >=       -----------------------------------------------------    38
    >r       -----------------------------------------------------     4
    >        -----------------------------------------------------    38
    ?dup     -----------------------------------------------------     2
    @        -----------------------------------------------------     5
    [[       -----------------------------------------------------    30
    [COMPILE] ----------------------------------------------------    30
    ]]       -----------------------------------------------------    30
    abs      -----------------------------------------------------    37
    and      -----------------------------------------------------    39
    asm      -----------------------------------------------------    21
    B!       -----------------------------------------------------     6
    B@       -----------------------------------------------------     5
    BEGIN ... END    ---------------------------------------------    10
    BEGIN .... ENDZ  ---------------------------------------------    17
    bload    -----------------------------------------------------    27
    block    -----------------------------------------------------    22
    brkoff   -----------------------------------------------------    43
    brkon    -----------------------------------------------------    43
    bswap    -----------------------------------------------------     2
    bye      -----------------------------------------------------    44
    CASE .. ENDCASE OF .. ENDOF ----------------------------------    15






    4th_86 version 4.02            GLOSSARY                   page  68
    
    cd         ---------------------------------------------------    59
    cgam       ---------------------------------------------------    61
    circle     ---------------------------------------------------    62
    close      ---------------------------------------------------    54
    cls        ---------------------------------------------------    49
    CODE       ---------------------------------------------------    19
    colortext  ---------------------------------------------------    50
    const      ---------------------------------------------------    22
    crlf       ---------------------------------------------------    52
    CROSS-COMPILE  -----------------------------------------------    36
    cross      ---------------------------------------------------    34
    CSP!       ---------------------------------------------------    33
    csp!       ---------------------------------------------------     4
    CSP@       ---------------------------------------------------    33
    csp@       ---------------------------------------------------     4
    cspick     ---------------------------------------------------     4
    cspush     ---------------------------------------------------    33
    DATA[      ---------------------------------------------------    23
    date       ---------------------------------------------------    58
    dayte      ---------------------------------------------------    59
    dbox       ---------------------------------------------------    62
    ddh        ---------------------------------------------------    46
    ddict      ---------------------------------------------------    48
    ddl        ---------------------------------------------------    47
    dds        ---------------------------------------------------    49
    dd         ---------------------------------------------------    46
    debug      ---------------------------------------------------    49
    define     ---------------------------------------------------    24
    define     ---------------------------------------------------    31
    depth      ---------------------------------------------------    49
    dictseg    ---------------------------------------------------    35
    dir        ---------------------------------------------------    60
    dline      ---------------------------------------------------    62
    dm         ---------------------------------------------------    49
    DO .... LOOP ( or +LOOP )  -----------------------------------    12
    dpix      ----------------------------------------------------    62
    drop      ----------------------------------------------------     2
    dspop     ----------------------------------------------------    33
    ds        ----------------------------------------------------    48
    dup@      ----------------------------------------------------     3
    dupb@     ----------------------------------------------------     3
    dup       ----------------------------------------------------     2
    dzhaltoff ----------------------------------------------------    44
    dzhalton  ----------------------------------------------------    44
    dzinst    ----------------------------------------------------    44
    dzrest    ----------------------------------------------------    44
    d         ----------------------------------------------------    63
    edit      ----------------------------------------------------    26
    egam      ----------------------------------------------------    63
    eganib    ----------------------------------------------------    63
    ELAPSED   ----------------------------------------------------    59
    END[      ----------------------------------------------------    11






    4th_86 version 4.02            GLOSSARY                   page  69
    
    ermsg       --------------------------------------------------    42
    espop       --------------------------------------------------    33
    espush      --------------------------------------------------    33
    exit        --------------------------------------------------     9
    F*          --------------------------------------------------    41
    F+          --------------------------------------------------    41
    F-1*        --------------------------------------------------    41
    F-          --------------------------------------------------    41
    F.          --------------------------------------------------    41
    F.          --------------------------------------------------    52
    F/          --------------------------------------------------    41
    F<          --------------------------------------------------    41
    F=          --------------------------------------------------    41
    F>          --------------------------------------------------    41
    fabs        --------------------------------------------------    41
    fcircle1    --------------------------------------------------    60
    FCIRCLE2    --------------------------------------------------    60
    files       --------------------------------------------------    42
    files       --------------------------------------------------    54
    fill        --------------------------------------------------     6
    find        --------------------------------------------------    24
    find        --------------------------------------------------    42
    fload       --------------------------------------------------    27
    float       --------------------------------------------------    41
    fmem        --------------------------------------------------     6
    forget      --------------------------------------------------    24
    fsave       --------------------------------------------------    54
    fullscreen  --------------------------------------------------    64
    gcolr       --------------------------------------------------    50
    GCOUT       --------------------------------------------------    52
    getchr      --------------------------------------------------    51
    getcli      --------------------------------------------------    42
    getdate     --------------------------------------------------    58
    getlin      --------------------------------------------------    51
    getloc      --------------------------------------------------    30
    getmode     --------------------------------------------------    49
    getsts      --------------------------------------------------    51
    getxy       --------------------------------------------------    50
    gotoxy      --------------------------------------------------    50
    gtdfa       --------------------------------------------------    24
    gtdfa       --------------------------------------------------    30
    gval        --------------------------------------------------    53
    HEAD!       --------------------------------------------------    29
    HEADB!      --------------------------------------------------    29
    head        --------------------------------------------------    34
    help        --------------------------------------------------    63
    hiseg       --------------------------------------------------    34
    hline       --------------------------------------------------    61
    I J or K    --------------------------------------------------    13
    IF .. ELSE .. THEN  ------------------------------------------    13
    IF[                 ------------------------------------------    14
    IFTRUE .. OTHERWISE .. ENDIF  --------------------------------    28






    4th_86 version 4.02            GLOSSARY                   page  70
    
    IFZ .... ELSE .... THEN --------------------------------------    17
    iload      ---------------------------------------------------    28
    iload      ---------------------------------------------------    36
    immediate  ---------------------------------------------------    21
    inithead   ---------------------------------------------------    33
    initlum    ---------------------------------------------------    33
    insrt      ---------------------------------------------------     3
    INT3       ---------------------------------------------------    45
    integer    ---------------------------------------------------    41
    isave      ---------------------------------------------------    36
    ivpage     ---------------------------------------------------    50
    kill       ---------------------------------------------------     3
    k          ---------------------------------------------------     2
    labels     ---------------------------------------------------    16
    last       ---------------------------------------------------    24
    last       ---------------------------------------------------    35
    link       ---------------------------------------------------    25
    load       ---------------------------------------------------    28
    lseek      ---------------------------------------------------    55
    lum        ---------------------------------------------------    35
    mod        ---------------------------------------------------    40
    MON1       ---------------------------------------------------    58
    MON2       ---------------------------------------------------    58
    move       ---------------------------------------------------     6
    ncgam      ---------------------------------------------------    61
    negam      ---------------------------------------------------    61
    newhead    ---------------------------------------------------    34
    newlast    ---------------------------------------------------    34
    newlum     ---------------------------------------------------    34
    nnorm      ---------------------------------------------------    61
    norm       ---------------------------------------------------    61
    number     ---------------------------------------------------    53
    OF[        ---------------------------------------------------    16
    oldhead    ---------------------------------------------------    34
    oldlast    ---------------------------------------------------    34
    oldlum     ---------------------------------------------------    34
    omit       ---------------------------------------------------    25
    open       ---------------------------------------------------    55
    or         ---------------------------------------------------    39
    over       ---------------------------------------------------     2
    page       ---------------------------------------------------    51
    patch      ---------------------------------------------------    48
    pat        ---------------------------------------------------    45
    pat        ---------------------------------------------------    48
    pdict      ---------------------------------------------------    45
    pdict      ---------------------------------------------------    48
    PI/2       ---------------------------------------------------    41
    pick       ---------------------------------------------------     2
    pi         ---------------------------------------------------    41
    plaintext  ---------------------------------------------------    50
    pnop       ---------------------------------------------------    45
    poke       ---------------------------------------------------     2






    4th_86 version 4.02            GLOSSARY                   page  71
    
    popdi     ----------------------------------------------------     4
    popdi     ----------------------------------------------------     5
    printload ----------------------------------------------------    28
    printloc  ----------------------------------------------------    28
    pshdi     ----------------------------------------------------     4
    putlin    ----------------------------------------------------     7
    Q-U-IT    ----------------------------------------------------    44
    r>        ----------------------------------------------------     4
    r@        ----------------------------------------------------     4
    read      ----------------------------------------------------    56
    recross   ----------------------------------------------------    36
    RECURSE   ----------------------------------------------------    11
    redefine  ----------------------------------------------------    29
    redit     ----------------------------------------------------    26
    reload    ----------------------------------------------------    26
    REPEAT .. WHILE .. ENDWHILE       ----------------------------    12
    repeat .... whilez .... endwhile  ----------------------------    18
    return    ----------------------------------------------------     9
    rot       ----------------------------------------------------     3
    savesys   ----------------------------------------------------    43
    secdelay  ----------------------------------------------------    59
    setmem    ----------------------------------------------------    43
    shl8      ----------------------------------------------------    39
    shr8      ----------------------------------------------------    39
    SP@       ----------------------------------------------------    33
    splitat   ----------------------------------------------------    64
    splitscreen   ------------------------------------------------    64
    split     ----------------------------------------------------    64
    status    ----------------------------------------------------    42
    strcat    ----------------------------------------------------     8
    strcmp    ----------------------------------------------------     8
    string    ----------------------------------------------------     8
    swap      ----------------------------------------------------     2
    synonym   ----------------------------------------------------    25
    sysclose  ----------------------------------------------------    56
    syslast   ----------------------------------------------------    33
    sysopen   ----------------------------------------------------    56
    sysrbyte  ----------------------------------------------------    56
    sysread   ----------------------------------------------------    57
    syswbyte  ----------------------------------------------------    57
    syswrite  ----------------------------------------------------    57
    sys       ----------------------------------------------------    43
    tag       ----------------------------------------------------    47
    TD        ----------------------------------------------------    59
    tdlock    ----------------------------------------------------    59
    time      ----------------------------------------------------    59
    tm        ----------------------------------------------------    59
    tracel    ----------------------------------------------------    47
    traceoff  ----------------------------------------------------    47
    traceon   ----------------------------------------------------    47
    tyme      ----------------------------------------------------    59
    type      ----------------------------------------------------    60






    4th_86 version 4.02            GLOSSARY                   page  72
    
    U>       -----------------------------------------------------    38
    unlink   -----------------------------------------------------    25
    unpat    -----------------------------------------------------    45
    unsplit  -----------------------------------------------------    64
    using    -----------------------------------------------------    26
    val      -----------------------------------------------------    54
    vline    -----------------------------------------------------    63
    W1       -----------------------------------------------------    65
    W1INIT   -----------------------------------------------------    64
    W2INIT   -----------------------------------------------------    64
    win1     -----------------------------------------------------    64
    WIN2     -----------------------------------------------------    64
    WINDOW   -----------------------------------------------------    65
    words    -----------------------------------------------------     2
    word     -----------------------------------------------------    52
    write    -----------------------------------------------------    58
    xor      -----------------------------------------------------    39
    xseg     -----------------------------------------------------    35
    xtrct    -----------------------------------------------------     3
            -----------------------------------------------------     9
3$