63$






           Getting Started    ------------------------------------     1
           Introduction       ------------------------------------     2

           Understanding the screen prompt  ----------------------     3
           Reverse Polish Notation  ------------------------------     3
           The FORTH stack          ------------------------------     5
           Clearing the stack       ------------------------------     6
           Examining the stack      ------------------------------     6

           Using DEBUG     ---------------------------------------     7
           Practice Time   ---------------------------------------     7
           Using TRACE     ---------------------------------------     8
           Disassembler    ---------------------------------------     9

           Entering Numeric values  ------------------------------     9
           Printing strings         ------------------------------    10
           Numerics in strings      ------------------------------    10
           Printing Numeric values  ------------------------------    10

           Defining new words       ------------------------------    11
           LINK                     ------------------------------    12
           Using the editor         ------------------------------    12

           Dumping memory and stack ------------------------------    14
           Dump Dictionary          ------------------------------    15

           DEBUG; TRACEON; TAG      ------------------------------    15
           TRACEL                   ------------------------------    15
           TM, TD, and SYNONYM      ------------------------------    16
           differences from normal  ------------------------------    16

           Variables and Constants  ------------------------------    18
           BLOCK                    ------------------------------    18
           CONST                    ------------------------------    18
           ,CONST ( comma const)    ------------------------------    19

           FLOAD                    ------------------------------    21
           ON REDEFINE              ------------------------------    21
           OFF PRINTLOAD            ------------------------------    21
           BLOAD                    ------------------------------    21

           :EXIT and :ENTER         ------------------------------    22
           OMIT                     ------------------------------    22
           Inline Assembler         ------------------------------    22

           How to compile demonstrations  ------------------------    22
           CROSS-COMPILE & UNCROSS        ------------------------    23
           ILOAD & ISAVE                  ------------------------    23

           COMMENTS IN CODE               ------------------------    24
           STATUS                         ------------------------    25
           MAP                            ------------------------    25







    (10U
    ͻ
                               Original CP/M80 version (c) 1982
                      ̹         United Controls Corporation
                         86        ͻ
     ͼ                                     Ŀ         
                                         Ŀ        / / /  
                                             Ĵ  \ \ \  
                                           Ŀ    Ĵ Ŀ 
                                            Ĵ        Ĵ 
                                                     
    ͼ                               
          Version 4.02  (c) 1994              Type HELP for tutorial     
     Larry Buchan      Din-Lo Software     ͼ


                                   4TH_86 
          ( based upon United Controls Corporation CP/M80 Forth.) 


                    ( Demo ) Version 4.02  November 1994
                                     by 

                                 M.F.Buchan 

                   Kinnell House 1 Argyle Place, Rothesay, 
                          Isle of Bute, PA20 0AZ, 
                               Scotland, U.K. 

                           Voice:  44-700-505185 

                           Compuserve 100012,651 

                    Internet: 100012,651@compuserve.com 


        Translation Copyright (c) 1988, 1989, 1993, 1994 M.F.Buchan 

         Original Copyright (c) 1982 United Controls  Corporation, 
                            Huntsville, Alabama. 






     4th_86                      MANUAL.4TH                       page 1
    

           See also GLOSSARY.4TH which containes many illustrative code
    examples.

           ===============
           Getting Started
           ===============

           The registered package provides three versions of the system.
    4TH_86.COM, 4TH_86DD.COM, and 4TH_86FP.COM. The first is a very minimal
    system with no disassembler; DOS shell; etc. 4TH_86DD has everything
    except floating point; double precision; and transcendental functions.
    These are added to create 4TH_86FP.COM.

           The downloadable demonstration version 4TH86DEM.COM is
    essentially the same as 4TH_86FP.COM -- but starts in tutorial mode --
    uses only page0 video as default -- has additional promotional text
    added -- a 3 second delay on exit -- and has certain other
    limitations as a consequence.

           Make sure that you have TUTORIAL.TXT in the same subdirectory
    as the executable file, and then from the DOS prompt, type 4TH86DEM
    <return> and you will be in 4th_86.  If you want to get back to DOS,
    type BYE. (QUIT has been re-named to Q-U-IT as it is no longer a
    preferred exit word).

           If you are using the DEMO version you will be automatically
    placed in the split-screen tutorial mode. To exit this type UNSPLIT.
    The tutorial can always be re-entered at any time by typing HELP.

           The screen contents can be dumped to printer using the normal
    IBM-PC keyboard keys SHIFT PRTSC. Also CTRL-P will toggle on and off
    duplication of screen output to printer. At the moment there are no
    printer-specific FORTH words implemented.

           By far the best way to learn is to work through the on-screen
    tutorial and the following manual. Indeed -- the PRIMARY objective
    of 4th_86 is to act as a self-sufficient teaching medium for
    newcomers to the language.

           Because of the obsessions which Forth "Wizards" relish about
    slavishly preserving old traditions -- any attempt to start the
    learning process by reading an "approved" text book first is liable
    to cause confusion and frustration.

           4th_86 is intended to be user friendly. Traditional FORTHs
    are motivated more by reverence for the past and cultivation of an
    arcane mystique by its devotees. While the language and grammar of
    Shakespeare and Chaucer may represent the English Language at its
    best -- it is hardly an appropriate medium for teaching every-day
    colloquial English to non-English speaking students. Nor for that
    matter in effectively expressing the basic concepts of ideas.






     4th_86                      MANUAL.4TH                       page 2
    
           =============
           Introduction
           =============

           It is useful to first consider what traditional FORTH
    embodies -- and what 4th_86 omits at one end -- and adds at the
    other. If you are a total newcomer to the language; you may choose
    to leave this section of reading till you have completed the
    tutorials, and gained some hands-on "feel" for what 4th_86 involves.

           If however you have previously struggled with a more
    traditional implementation of FORTH and become disillusioned -- then
    reading this discussion first may help to put things in perspective.

           If you insist on reading a text  -- then one of the better
    books is FORTH: A text and Reference by Mahlon G. Kelly and Nicholas
    Spies -- Prentice Hall -- 1986. Even this book however is heavily
    steeped in tradition -- and it will certainly in no way reflect the
    IDE and ergonomic aspects of 4th_86.

           The extended discussion of traditional FORTH and of 4th_86
    has been extracted to a separate file -- WHY.4TH.

           All you need note for now is that 4th_86 uses conventional
    DOS and ASCII CR-LF delimited text files for source code. It does
    not use so called 1024 byte "screen files" of traditional FORTH's
    video-memory image dump. 4th_86 files are totally DOS compatible.

           4th_86 attempts to create a user-friendly IDE ( integrated
    development environment ) whereby editing is by your own familiar
    DOS editor of choice [ in my case Vedit Plus ] ; accessed directly
    from within 4th_86; and able to automatically edit/reload edited
    FORTH source repetitively.

           The 4th_86 IDE also allows two methods of implementing
    assembly code. One is direct in-line use of conventional INTEL
    mnemonics within FORTH definitions. No reverse polish modification
    is necesary in the mnemonic format. Structured conditionals such as
    IFZ .. THEN are available; and so also is the standard MASM use of
    forward and backwards referenced labels.

           The other method of implementing Assembly is by placing the
    ASM source in its own DOS disk file; and integrating a standard DOS
    Assembler [ in my case MASM 5.0 ] into the 4th_86 IDE. Assembly
    takes place "transparently" when the source file is BLOADed into the
    system.

           Both the editing and assembly take place on a separate video
    memory page from the 4th_86 system display itself. This means that
    screen text from these activities does not over-write or become
    intermixed with the screen text from the 4th_86 system.






     4th_86                      MANUAL.4TH                       page 3
    
           ==================
           Understanding the screen prompt
           ==================

           Your first view of 4th_86 will be the signon logo -- followed
    by a DOS style prompt which should say

                _0_ 4th86 

           If you are running the DEMO version, the lower half of the
    screen will be colored and will contain instructions on using F1 and
    F2 to step through the inbuilt tutorial. Even if you have some prior
    experience with FORTH --- work through the tutorial as it displays
    many of the features which are unique to the 4th_86 implementation.

           If you type the word UNSPLIT and press <return> you will exit
    the split screen tutorial mode and come to the plain white on black
    ascii display that the registered versions open in by default.

           Some people feel white text on a black background is too
    bland for their eyes. Personally I prefer it as being less strain on
    the eyesight -- but if you like high intensity glare, the word
    COLORTEXT will give yellow text on a blue background. The word
    PLAINTEXT will restore white on black. The contents of variable
    GCOLR determine what the color is.

           The other aspect of the prompt is the number _0_ -- which
    represents the "stack depth" -- that is the number of parameters
    that have been pushed on the FORTH stack.

           The concept of the FORTH stack is explained below. First
    however let's have a look at the reasons for RPN.

           ==================
           Reverse Polish Notation
           ==================

           An essential premise of FORTH is that the interpreter or
    compiler should not have to carry out the additional burden of doing
    the programmer's thinking for him.






     4th_86                      MANUAL.4TH                       page 4
    
           When we ask someone to work out x = (3 + 4), it is not
    realised how much mental "pre-processing" is required before the
    addition can be completed. The thought process is in effect

           a) x =   eh??? how can I assign a value to x -- I don't
                          yet have any data to play with. I'll keep
                          that issue in the back of my mind.

           b) 3     oh, no problem with this one  -- write it down
                    -- but I still don't know what to do with this
                    variable x that you gave me.

           b) +     eh??? -- I don't have anything to add to 3
                      -- how am I expected to handle this operator
                      request. I guess I'll just have to shove it on
                      the "real soon now" list along with X

           c) 4     ahhh! --- now I have two bits of data -- what was it
                     that I was asked to do?? Add them -- ok -- write
                    the 4 down underneath the 3 and then draw a line
                    underneath -- add them -- result is 5
                     Real lucky I decided to have the foresight to
                    remember  that addition instruction till later

           d)  Now what do I do -- oh yes -- assign the answer to
                     variable X -- so we have X = 5

                                            3
                                            4
                                               +
                                          ========
                                            5
                                             store it in varable X

    "Reverse Polish Notation" is simply a process of feeding data and
    operators to FORTH in an "as needed" order. In FORTH the above
    calculation would be written

                            3  4  +  X  !

       [ we will see later that the special symbol "!" means "store" ]

    Another example is

                   10   9   4   3   +   -    *

                                    which would  evaluate as

                     add         3  to  4     to get    7
                     subtract    7 from 9     to get    2
                     multiply    2  by  10    to get    20






     4th_86                      MANUAL.4TH                       page 5
    
           ==================
           The FORTH stack
           ==================

           Where are these numbers 10  9  4  etc retained for
    processing? They are in fact pushed on to a stack [ or queue ] in
    much the same way as plates which have just been washed are stacked
    on top of each other.

          The last plate to have been washed lies on "top of the stack"
    and the immediately previous plate is "next on the stack".

           These concepts are given the acronyms TOS [ top of stack ]
    and NOS [ next on stack ] in FORTH terminology. The following data
    entries are referred to as 3OS, 4OS etc.

           Fire up 4th86DEM [ or 4th_86FP ] and type

                     10   < return >
                      9   < return >
                      4   < return >
                      3   ( return >

                  As each data value is pushed on to the stack by
    pressing <return>, the value of the stack depth _0_ on the  screen
    prompt will increase by 1. You will then have

                      3   as   TOS
                      4   as   NOS
                      9   as   3OS
                     10   as   4OS

           The same result could have been achieved by typing

                    10   9   4   3   < return >

           *** Note that each of the above values is stored on the stack
               as a 16 bit signed value.  Values in the [ decimal ]
               range -32768 through +32767 are therefore possible.

               By prefixing the data with a comma --- ,10  ,9  ,4  etc,.
               the numbers will be stored with "double precision". That
               is as a 32 bit [ 4 Bytes ] number covering the range -
               2147483648 through +2147483647.

                For each double precision value pushed on the stack, the
                stack depth prompt will increment by 2           ***






     4th_86                      MANUAL.4TH                       page 6
    

           ==================
            Clearing the stack
           ==================

           One of the features of FORTH is that any error automatically
    clears the stack of all data. All that is needed to clear the stack
    and reset the depth to _0_ is to type in some garbage and press
    <return>

           For example   k;lk;k <return>

           will produce the message

           * ERROR *   symbol k;lk;k is UNDEFINED

                            and clear all data from the stack.


           ==================
            Examining the stack
           ==================

              One of the biggest problems for beginners is remembering
    exactly what the values on the stack represent; where the particular
    one you wish to access lies in the queue; and how to get them as TOS
    and NOS in order to do arithmetic on them.

           This difficulty is more than compensated for by the fact that
    [ compared with other languages such as C, Pascal, or even Basic ]
    it is so simple to manipulate values on the stack and test words [
    "functions" are known as "words" in FORTH ] interactively.

           This is ** THE ** primary advantage of FORTH as a programming
    language. The ability to debug code is inherent in the structure of
    FORTH.  With the additional debugging utilities that are built in,
    FORTH becomes a much more programmer friendly environment than
    compile-only languages.

           Two debugging words are DS [ display stack ] and DDS [
    destructively display stack.

           Clear the stack -- and then type in

                    10  9  4  3  < return >
                       DS        < return >

      and the screen will display     000A  0009  0004  0003

            note that the TOS is on the right of the stack dump and the
    data still remains on the stack undisturbed. Repeat using DDS
    instead of DS -- and the stack will be left empty.






     4th_86                      MANUAL.4TH                       page 7
    

           ===========
           Using DEBUG
           ===========

           A much easier way of examining stack operations is to use the
    system switch DEBUG. This is a toggle -- the first time the command
    DEBUG <return> is typed -- the debug display will be switched on.
    The next time DEBUG is issued -- the display will be turned off.

           Clear the stack by typing DDS and then type

            10  < return >
             9  < return >
          debug < return >
             4  < return >
             3  < return >
                           and you should see the possibilities.

           Now [ with DEBUG toggled on -- and the above four values on
    the stack ] --- type

              +  < return >
              -  < return >
              *  ( return >
                              and verify that the arithmetic operators
    in fact behave as described earlier.

           ===========
           Practice Time
           ===========

           Now that you know how to enter and interactively examine the
    stack; place some numerical values on the stack and work through the
    Glossary sections 1. 16. 17. and 18. That is Stack manipulation;
    Arithmetic;  Comparisons; and Logic.

           Enter hex values on the stack  along with decimal

                     23H  23  1234H  1234

           Print out stack values using the "dot" operator . which will
    print the decimal value. Repeat using .H to print Hex values.

           Try also entering binary values with 1000101B and printing
    them with .B and .H






     4th_86                      MANUAL.4TH                       page 8
    
           Then practice [ still using the DEBUG display ] the use of
    double precision calculations such as

             ,10  ,9  ,+  ,3  ,-  ,2 ,*   ,.

           And do the same with floating point

                    10.1  < return >
                    9.2   < return >
                    F+    < return >
                   ,dup   < return >
                    F.    < return >
                   3.2    < return >
                    F/    < return >
                    F.    < return >

           This should give the final answer 6.03125.

     The actual numerical values on the stack when Floating Point is
    involved will seem very strange,  -- but the interpretation is
    explained in the file FPOINT.DOC.

           ===========
           Using TRACE
           ===========

           Now let's do the above calculations again -- but within a
    word definition.

           Type  : FRED  10 9 4 3 + - / . ;

           and   : KEN 10.1 9.2 f+ ,dup f. 3.2 f/ f. ;

           We have now created two word definitions which evaluate the
    previous calculations.

           Type
                     TRACEON FRED
                     FRED
                                       Then try
                                                TRACEON KEN
                                                ken

                                         TRACEoff fred KEN


           *** Note that 4th_86 is not case sensitive. ***


          Now try   DD KEN   and  DD FRED








     4th_86                      MANUAL.4TH                       page 9
    
           ============
           Disassembler
           ============

           "DD" is the 4th_86 word which calls up the diassembler. It
    must be followed by the word you want to disassemble.

           To show the use of the disassembler, let us see how the word BYE
    is made up. Type DD BYE and then press <return>. This will show you
    that BYE makes use of several other Forth words such as PAGE0, BRKON,
    SECDELAY.

           Look at each of these words by typing DD PAGE0 etc. Unlike BYE
    itself - you will see that PAGE0 and BRKON are pure assembly code.
    SECDELAY is interesting in that most of it is assembly code -- but a
    part in the middle is Forth code. It is quite simple to mix assembly
    and Forth source in this manner. The actual source code for SECDELAY is
    provided on disk.

           You can also try DD THREAD, DD COLON, and DD SRET if you wish.
    In fact you can type DD followed by any 4th_86 word and it will be
    disassembled.

           Perhaps a better word to demonstrate how Forth and Assembly
    can be mixed is the word GC. Type DD GC and then use ctrl-S to pause
    and start the display.

           You may get OOPS displayed in the disassembly -- and this simply
    means that the word which ** should ** appear there has been removed
    from the dictionary. There are two reasons for doing this -- to save
    space -- and because a ** very ** large number of the words needed to
    build up the system from source are of no use at all in normal use.

           You can not of course disassemble any word which has been
    removed from the dictionary.

           The display can be "aborted" at any time by pressing the space
    bar. Ctrl-S will start and stop the display.

           Ctrl-C and Ctrl-Brk are normally disabled, as using them would
    dump you back into DOS. The word BRKON turns the ctrl-Brk facility
    on again, and BRKOFF turns it off.

           =======================
           Entering Numeric Values
           =======================

           Here is one place that 4th_86 differs from all other Forths.
    Numbers can be input in Hex, Binary, Decimal or Octal. In 4th_86
    considerable flexibility is introduced by using the same notation as
    when writing ASM code -- a suffix after the number -- 123H -- 123Q ( or
    123O) -- 11011B for Hex, Octal, Binary respectively.






     4th_86                      MANUAL.4TH                      page 10
    
           Decimal is the default, so for 123 decimal just type in 123.
    ASCII values can be inserted as "A" rather than 41H -- or "B" "C"
    "D" etc.

           ================
           Printing Strings
           ================

           Unlike standard Forths, the dot-quote word  (  ."  ) does not
    double as part of the initial string quote. It is a separate word.

           4th_86 =>        " this is a test" ."
           Other Forths =>  ."this is a test"

           Note also that in 4th_86 a space is needed between the first
    quote sign and the start of the string text. This is because the
    leading " is a Forth word just like any other word. The closing " is
    not a word -- it is an end of string delimiter.

           ===================
           Numerics in Strings
           ===================

           String values are entered between quotes

           " this is a test"

          If it is required to enter specific numeric bytes as part of the
    string -- for example 0D Hex and 0A Hex -- this is done by using the
    up-arrow ^

           " ^0dh 0ah^this is a test"
           or   " ^13 10^this is a test"


           The result of course is the same as

           crlf " this is a test"

           There is a file on disk called FRENCH.4TH which can be loaded [
    type FLOAD FRENCH.4th ] and will demonstrate how special accented
    characters and ascii graphics can be displayed.

           =======================
           Printing Numeric Values
           =======================

           To print out the value on the TOS (top of stack) the operators
    .H .L .HB .C and . are provided.






     4th_86                      MANUAL.4TH                      page 11
    
           .H prints a word in Hex with a leading space. .HB prints a
    byte in Hex with leading space. A single period  . prints the TOS in
    decimal with a leading space.

           .C prints the ASCII character if one exists -- but with no
    leading space.

           .L is the same as . but without a leading space. It's main
    purpose is for sending ANSI control codes requiring numeric parameters.
    A leading space would invalidate the ANSI sequence.

           Try the following at the 4th86 prompt

           20H 16 "C" + + dup .H crlf dup . crlf 30H - .C

           Try also the following

           20H 16 "C" + + dup .h 3 spcs dup . 3 spcs 30h - .c

           In normal Forths different number bases can not be mixed. It is
    necessary to define a variable BASE as either HEX DECIMAL etc. 4th_86
    does not have this clumsy restriction.

           Whilst there used to be a variable called BASE in 4th_86 it
    had nothing to do with number bases, and was never used in normal
    events. It was the relocation offset used when meta-compiling stand-
    alone COM programs. It is no longer used in version 4.02.

           If you print out a value when the stack is empty you will get
    a negative value of depth display.

           In addition to the auto-depth display, the word DEPTH is
    available to use within definitions.


           ==================
           Defining new words
           ==================

           Type   : Fred 3 . ;

           This defines a word Fred -- which simply prints the value 3
           Type  FRED (or fred FrEd fREd) and you will see  3  printed
           (out of curiosity, disassemble with DD FRED )

           Type   : Fred 4 . ;

           You will be asked if you want to redefine Fred -- answer Y
           Type FRED and and you will see that  4  is now printed instead
           of 3






     4th_86                      MANUAL.4TH                      page 12
    
           Now type
                    : Larry 4 ;
                    : Tom Larry 2 * . ; and then type TOM
                            TOM

           You should get an 8 printed -- Larry pushes the value 4 on
           the stack -- which is then multiplied by 2.

           Let's redefine LARRY

                    : Larry 6 ;      ( and of course answer Y )

           Now type TOM --- and you will find that you do not get 12
    printed - you still get 8.

           The redefinition of LARRY from 4 to 6 has not affected the prior
    definition of TOM. This is the normal way with Forth. When TOM was
    defined -- it used the definition of LARRY that was current at the
    time. The redefinition of LARRY ** after ** the definition of TOM
    does not affect TOM's use of the original LARRY definition.

           A clearer picture of all the words you have entered can be seen
    if you type DDICT.

                  Now let's see how we can actually replace the old
    definition with a new one.

           ====
           LINK
           ====

           Type DD LARRY  and you will see the constant 6

           type FORGET LARRY  and then DD LARRY and you will see that we
    are now back to our original definition of LARRY as the value 4

           type  : KEN 6 ;

           LINK LARRY KEN     ( ignore the warning message )

           TOM

           you should get the value 12 printed. All calls to the last LARRY
           are now diverted to KEN instead. Try DD LARRY and DD KEN.


           The last word linked can be restored with UNLINK

           Type UNLINK   which unlinks LARRY from KEN
           type  TOM  and you should get 8
           type DD TOM   DD KEN  and  DD LARRY to confirm






     4th_86                      MANUAL.4TH                      page 13
    
           ================
           Using the editor
           ================

           Make sure you have read and implemented the instructions in
    INTRO.4TH for configuriing EDITR.BAT and ASMBL.BAT.

                  You must first tell 4th_86 the name of the file you want
    to edit. The default name built into 4th_86 is EDHELP.TXT -- so if you
    type EDIT you should get this help message displayed by your editor.

           The word USING allows you to change the default file name to
    another one. To edit a different file -- say  SQ.4TH -- first type
    USING SQ.4TH -- then all future uses of the word EDIT (and the words
    REDIT and RELOAD) will call up the file SQ.4TH.

           The editor is designed to be much more flexible than this
    however. After editing a Forth source file, the normal procedure would
    be to re-load it for testing and debugging. For this purpose, the words
    RELOAD and REDIT exist.

           RELOAD behaves the same as FLOAD except that it uses the name
    already specified by USING. Therefore

           FLOAD SQ.4TH is the same as having executed USING SQ.4TH and
    then executing RELOAD

           REDIT also uses the name specified by the previous USING and is
    equivalent to  EDIT followed by RELOAD.

           The normal edit => fload => test => re-edit cycle is simplified

           Try        USING SQ.4th
                      FLOAD SQ.4th
                      DD OSQUARE
           REDIT
           <==> DD OSQUARE

           REDIT
           <==> DD OSQUARE   where <==> are the steps to exit from
           the editor you are using.

           You will see by the addresses attached to the DD disassembly
           that each REDIT redefines a new OSQUARE, getting higher and
           higher in memory.

           To confirm this -- type DDICT and examine how many copies of the
           word OSQUARE you have loaded.

                  This multiple redefinition can be avoided by defining a
    dummy word -- say STRT -- and starting your source file with FORGET
    STRT






     4th_86                      MANUAL.4TH                      page 14
    
           Try

           USING SQ.4TH
           : STRT ;
           FLOAD SQ.4TH
           DD OSQUARE

           REDIT
                  < add the words FORGET STRT
                      and : STRT ;   to the start of the file >
           <==> DD OSQUARE
           REDIT
                now the re-load of the newly edited file SQ.4TH
           causes deletion of the previously loaded file.

           Following this tutorial should now be much easier as a hands-on
    process. Instead of trying to key into 4th_86 lengthy definitions
    directly from the keyboard, they can be edited into a test file, and
    the file loaded.

           Lower and upper case are equivalent, whether entered from the
    keyboard or floaded from a file. Of course, case in quoted strings is
    preserved

           " Hey There" ." will be printed   Hey There  - not capitalized
           nor all lower case.


           ========================
           Dumping memory and stack
           ========================


           DM  8DM  and 16DM are memory dumps -- try 2000H 8DM  etc.

           NOTE that there is a number left on the stack after the dump is
    completed. Use .H to display this value and you will see that it is
    2080H. The purpose of this is so that the dump can be continued simply
    by typing 8DM again [ or 16DM or whatever ].

           DS and DDS are stack dumps

           try   2 3 4 5 DS <return>
           DS  <return> DS <return>
           DDS <return> DS <return>

           DS prints out the stack values, and leaves them unchanged
           DDS (destructive dump stack) prints the values and removes them

           try   2 3 4 5 <return> DS <return> abcd <return>  DS <return>






     4th_86                      MANUAL.4TH                      page 15
    
           this is a convenient way to clear and reset the stack -- type in
    any meaningless phrase (i.e. - abcd), press return, and the error
    message clears the stack.

           ===============
           Dump Dictionary
           ===============

           Type DDICT and you will be presented with a display of the words
    in the dictionary, together with the address of the dictionary entry
    and flag byte (high segment ) and the start offset of the code area (
    low segment ). The display has now been arranged to pause every 15
    items. RETURN produces the next 15 entries. Any other keypress aborts.

           Type PDICT DUP and instead of returning all the words in the
    dictionary, you will just get the addresses for the word DUP.

           ===================
           DEBUG; TRACEON; TAG
           ===================

           We already have TOM defined

           Type TRACEON TOM  and then TOM

           the word is traced, and stack values are displayed

           TRACEOFF removes the trace, and TAG (trace-again) restores it

           applying TRACEON to another word automatically removes it from
    the old one

           any errors -- as well as clearing the stack -- also remove
    TRACEON

           DEBUG is an on/off toggle.

           type TRACEOFF to be sure -- and then type DEBUG  ( to toggle
    debug on)

           now type   3 4 5 6 <return>
           . .    <return>
           DDS    (return>
           DEBUG ( to toggle it off)

           this display of stack contents is useful.



           ======
           TRACEL
           ======






     4th_86                      MANUAL.4TH                      page 16
    
           This is Trace-level and is used for tracing DO...LOOP structures

           Type   : SLOOPY  5 0 do I . loop ;

           then run it by typing SLOOPY
           you should get  0 1 2 3 4 5  displayed on the screen

           now   TRACEON SLOOPY
           SLOOPY   -------- not very impressive

           3 TRACEL
           SLOOPY  ---- somewhat better ???


           ===============
           TM; TD; SYNONYM
           ===============

           Type TM and the time will be shown

           Type TD <return> and then TD <return> again.
           the elapsed time between the two events is shown

           Try  : dly1 1000 0 do loop ;
           : dly td 10 0 do dly1 loop crlf td crlf ;

           then run by typing DLY.

           The SECOND line shows the elapsed time to complete the word DLY
    -- measured between the first TD and the second TD.

           No -- indeed this system is not as fast as many others -- but at
    the moment speed is not the objective. The objective is a user-friendly
    interface which will allow ease of code writing and learning for
    beginners.

           So you think TM is too terse and non-standard?

           well try   SYNONYM TIMEELAPSED TD

           and type TIMEELAPSED -- purists can build synonyms for any word
           they think "non-standard" (or modify the source) and create  a
           new system file using SAVESYS.






     4th_86                      MANUAL.4TH                      page 17
    

           =======================
           differences from normal
           =======================

           4th_86 is different from other implementations of FORTH in
    several ways. Some of the differences are because of the targeted
    applications of FORTH such as the fact that the dictionary is stored
    separately from the code so compact stand-alone code can be generated.
    Other differences arise because of adding features not commonly found
    in other FORTHs, different naming conventions, and different
    philosophies in the implementation.

           Listed below are some of the minor differences that may
    "disturb" the user of a more conventional FORTH. SYNONYMS or short
    words can be used to re-define the more familiar names. For example:

           SYNONYM  EMIT  .C

           or

           : KEY 0 BEGIN DROP 255 6 MON2 DUP END ;

           After the table below is a discussion of several more
    significant differences.

           Many FORTHs         4th_86           exact
                              Equivalent       replacement

           C@                      B@
           C!                      B!
           EMIT                    .C

           KEY                                  0 BEGIN
                                             DROP 255 6 MON2 DUP
                                                    GETCHR  END

           TYPE                                 1 DO DUPB@ .C
                                                   1+ LOOP DROP  ."

           VARIABLE              DATA[ ...]
           CONSTANT              CONST
           ."string"           " string" ."
           ABORT" string"      " string" 1 ERMSG
           LEAVE                 EXIT
           BEGIN..UNTIL          BEGIN...END
           BEGIN..WHILE..REPEAT  REPEAT..WHILE..ENDWHILE
           D+  D=  etc.          ,+  ,=  etc.






     4th_86                      MANUAL.4TH                      page 18
    
           In 4th_86, DO..LOOPs terminate when the loop count is exceeded,
    not equaled.  Also in most FORTHs, the loop is always executed at least
    once, while in 4th_86 the loop index is checked against the limit
    before the loop is executed (loop skipped if limit exceeds maximum). In
    4th_86, loops cannot use negative increments, When the word EXIT
    (corresponds to LEAVE) is executed, the loop is exited immediately
    (most FORTHS set the loop limit equal to the current loop index).

           The file SHARPS.4th contains source for double precision
    formatted output routines -- it also includes a self loading and
    executing demonstration of these.

           CREATE...DOES is not included as such, but the file ARRAY.4th
    shows how defining words can be created. This file also contains a self
    exeuting demonstration.


           =======================
           Variables and Constants
           =======================


           BLOCK
           =====

           Purpose: Reserves a block of contiguous memory where
           the size of the block is on the TOS and the name of the
           block is the next word. When the name is executed, the
           address of the block of memory associated with it is
           placed on the stack.

           ?? block_size --- ??  ( when BLOCK is executed )

           ?? --- ?? address     ( when the name of the block
           is executed )

           Example:   Reserve 25 bytes of memory and name it
           BUFFER.
           25 BLOCK BUFFER ( A buffer which is 25 bytes long )

           Example:  Assume that the address of BUFFER is 453EH.
           Using the word .H print the address of BUFFER.

           BUFFER .H
           453E   ( this is printed on the console )






     4th_86                      MANUAL.4TH                      page 19
    
           CONST
           =====

           Purpose: Defines a constant whose value is on TOS and
           name follows CONST. When the name is executed, the
           value associated with that name is placed on TOS. Only
           single precision integers may be used as the value of a
           constant.

           ?? value -- ?? ( when CONST is executed )
           ?? -- ?? value ( when name of constant is executed )

           Example: Define the constant B_SIZE whose value is
           1100. Also, using the word . print the value of SIZE.

           1100 CONST B_SIZE
           B_SIZE .
           1100  ( this is printed on console )




           ,CONST ( comma const)
           ======

           Purpose: ,CONST is similar to CONST except a double
           precision constant is defined.

           ?? --- ??

           Format: value ,CONST name



           DATA[ ( data left bracket)
           ======

           Purpose: Defines a block of memory with the values
           between DATA[ and ] with the name of the block
           following ]. The values may be:

           1. one byte integers
           2. two byte integers
           3. strings with a length byte
           4. strings without a length byte


           When the name of the block is executed, the address of
           the block associated with the name is placed on the TOS






     4th_86                      MANUAL.4TH                      page 20
    
           There are special words which allow the data type to
           vary as mentioned above. The words are:

           BYTE
           WORD
           LENGTH
           NOLENGTH

           and are respective to the meanings 1 through 4 above.
           The defaults are WORD and LENGTH. When these words are
           detected, all remaining values have the same data type
           until either a new defining data  type is encountered
           or a ] is found, which ever comes first. Note that '
           and " can be used in DATA[

           ?? --- ??
           Example: Define TABLE whose values and format are:

           145          ( one byte)
           5394         ( one byte)
           13           ( two bytes)
           " HI"        ( with length byte)
           423EH        ( two bytes)
           " HELLO"     ( no length byte)

           and write a word, TEST which prints each value one per
           line.

           DATA[ BYTE 145 5394
           WORD 13
           LENGTH " HI"
           WORD 423EH
           NOLENGTH " HELLO" ] TABLE

             : TEST
               table dupb@ . crlf
               1+ dupb@ . crlf
               1+ dup . crlf
               2+ dup ." crlf
               dupb@ + 1+ dup@ .H crlf
               2+ dup 4 + swap do
                 I b@ .C
               loop
             ;
           when executed TEST should give the display

              145
              18
              13
              HI
               423E
              HELLO






     4th_86                      MANUAL.4TH                      page 21
    
           =====
           FLOAD
           =====

           This has already been described. An alternative to FLOAD
    FILE.ABC would be   " FILE.ABC" LOAD. The use of the word FLOAD avoids
    the need for string quotes.

           ON REDEFINE
           ============

           REDEFINE is a flag which determines whether the compiler will
    give a warning or not when a re-definition is encountered. ON REDEFINE
    allows words to be redefined without warning. OFF REDEFINE causes
    warning messages.

           OFF PRINTLOAD
           =============

           PRINTLOAD is a flag which determines whether the file will be
    listed on the screen as it is loaded. OFF PRINTLOAD allows the file to
    load without being displayed on the screen. ON and OFF PRINTLOAD can be
    scattered throughout a file if parts are to be observed during loading
    -- as indeed can ON and OFF REDEFINE.

           =====
           BLOAD
           =====

           BLOAD is used for COM files created by MASM. It does ** NOT **
    check for re-definition so care is needed not to duplicate words.

           This feature has been briefly described in INTRO.4TH and will
    not be elaborated in this shortened manual. In-line assembly is
    available and will normally be the preferred method.

           There is however a file TEST.ASM provided, which you can use [
    issue the command BLOAD TEST --- do **not** use the .ASM suffix ]. The
    first time you BLOAD this file it will automatically compile into
    TEST.BIN [ provided you have configured ASMBL.BAT properly ] and then
    load the TEST.BIN into 4th_86.

            By examining the source for TEST.ASM you will see that it
    defines three words FIRST SECOND and THIRD. If you execute these words
    they each print a message.

           BLOAD only compiles the target file into BIN if there is no BIN
    file already existing -- or if its date is earlier than that of the ASM
    file. If you use BLOAD TEST again it will no longer compile TEST.ASM --
    unless you delete TEST.BIN first -- or edit TEST.ASM to give it a later
    date.






     4th_86                      MANUAL.4TH                      page 22
    
           ================
           :EXIT and :ENTER
           ================

           These allow changes from assembly to colon ( :ENTER) and from
    colon to assembly ( :EXIT) within the same word definition. See the
    file SECDELAY.4TH



           ====
           OMIT
           ====

           As the number of words added to the system increases, it soon
    becomes necessary to "prune out" the garbage entries in the dictionary.
    All code entered has a dictionary entry, -- and is referenced by other
    code. A good 50% of the code entered however will never be needed for
    external applications, and maintaining a dictionary pointer to it is
    simply a waste of space.



           ================
           Inline Assembler
           ================

           This feature has again been described briefly in INTRO.4TH and
    will not be elaborated on in this limited manual.

           There are however two files MASM.TST and MASMTST which were used
    in developing the assembler. These can both be FLOADed -- or examined
    to see the format of entering inline assembly instructions.

           Both files end by calling upon the disassembler to display the
    code that was just loaded. The object was to check that the assembler
    and disassembler were consistent.

           Many of the source files for the system have both inline
    assembly; BLOADable assembly; and plain FORTH code. Much can be learned
    by examining these.



           =============================
           How to compile demonstrations
           =============================

           To create SINE.COM simply bring up 4TH_86 and then type FLOAD
    SINCOM.DEM   The process will end by exiting to DOS. Look at the file
    SINCOM DEM which automates the building process, and the file SIN.4TH
    which is the source for the demonstration, to see what is happening.






     4th_86                      MANUAL.4TH                      page 23
    
           Similarly you can FLOAD SMITH.DEM to produce SMITH.COM -- and of
    course FLOAD HILCOM.DEM will produce HILBERT.COM.

           HILSIER2 is used exclusively by HILCOM.DEM to produce
    HILBERT.COM -- and omits the facility for defining levels and
    magnification. If you examine the source code however, you will see
    commented out the relevant code to allow level and magnification to be
    specified from the 4th_86 command prompt. You can edit HILSIER2.4TH [
    or use HILSIER.4TH ]  to reinsert the omitted code - and then reload.
    The easiest way is by using REDIT as already described.

           =======================
           CROSS-COMPILE & UNCROSS
           =======================

           The demonstrations which you created above were created in
    CROSS-COMPILE mode. The 4th_86 system provides the user with a means of
    compiling any system provided either image [ xxx.IMG ] or source code
    files are available for all the words needed.

           The cross-compiler is not a separate compiler, instead it is a
    mode in which the compiler executes. The compiler runs in one of two
    modes: cross-compile or noncross-compile. Until specified, the compiler
    will operate in noncross-compile mode. Executing the word CROSS-COMPILE
    switches to the cross-compile mode.

           Unlike earlier versions of 4th_86, CROSS-COMPILE now needs no
    parameters. Because all cross compile activity is in its own dedicated
    segment, it starts at offset 100H and has it's upper limit close to the
    64K offset limit.

           several points need to be noted

           a) code generated in cross-compile mode can ** NOT ** be run
    during the process of cross compiling. All offsets are identical to the
    final code produced -- but the segment is inappropriate.

           b) all code forming part of the "mother system" can be run in
    cross-compile just as in noncross mode. Obvously this is essential or
    the compiler would be "dead".

           c) cross-compiled definitions can not reference a word which has
    not already been itself defined in cross-compile. The word may already
    exist in the mother system -- and be executable -- but attempts to use
    it in a cross-compie definition will give an error message.

           d) Cross-compile creates its own dictionary, and FIND will
    reference this dictionary to determine code addresses ** NOT ** the
    system dictionary. The system dictionary is only used for words in
    immediate mode.






     4th_86                      MANUAL.4TH                      page 24
    
           ISAVE
           =====

           This is only used during cross-compile. At any stage of partial
    completion of the cross-compile, the memory image can be saved by using
    ISAVE  FNAME.IMG

           ILOAD
           =====

           This allows a previously saved xxx.IMG file to be re-loaded in
    the cross-compile mode. Unlike earlier versions of 4th_86, image files
    are not system sensitive because cross compile takes place in a
    dedicated segment - and always at offset 100H.

           COMMENTS IN CODE
           ================

           Forth or in-line assembly code between brackets is treated as
    comments and ignored by FLOAD.

           for example  : comment_test  2 ( first variable )
                                        3 ( second variable )
                            dup ( stack is 2 3 3 )
                            *   ( 3 * 3 gives 9 )
                            +     2 + 9 gives 11 )
                            .    ( print answer )
                            ;    ( end word definition )

           To assist in following complicated if -- then -- else and mixed
    conditional statements; the usual practice of indenting has not been
    used. Instead the ascii-graphic character B3 Hex [ 179 decimal ] is
    ignored by 4th_86 when encountered in FLOADed code. This character is a
    vertical line and its use is shown by the following sample.

           : DS ( DISPLAY STACK ELEMENTS IN HEX)
                  SP@ CLISP @ SWAP - 2 / DUP 0>
           IF ( SOMETHING ON STACK)
           
            BEGIN
                   DUP 1+ PICK .H   ( PRINT IT)
                   1 - DUP 0=
            END DROP crlf
           
           ELSE
           
            IF ( underflow)
                   " STACK UNDERFLOW ... RESETTING STACK." 1 ERMSG
            THEN
                " STACK EMPTY." ." CRLF
           
           THEN ;






     4th_86                      MANUAL.4TH                      page 25
    
           ======
           STATUS
           ======

           STATUS is a word which prints out the dictionary and code space
    available at any stage. In cross-compile mode it prints additional
    information.



           ===
           MAP
           ===

           " xxxx.yyy" MAP will create a file xxxx.yyy showing all the
    words loaded into a system either in cross-compile or noncross mode. It
    will not list the words already embedded in the "mother" system.



           ==========
           CONCLUSION
           ==========

           The main features of 4th_86 have been outlined. The Glossary
    will define individual words -- and give  many illustrative
    examples.

          It also gives a description of the memory layout and
    dictionary structure.






     4th_86                      MANUAL.4TH                      page 26
    


    ,+ ,= etc   --------------------------------------------------    17
    ,CONST      --------------------------------------------------    19
    ."          --------------------------------------------------    10
    .C          --------------------------------------------------    10
    .H          --------------------------------------------------    10
    .HB         --------------------------------------------------    10
    .L          --------------------------------------------------    10
    .           --------------------------------------------------    10
    16DM        --------------------------------------------------    14
    4TH86DEM    --------------------------------------------------     1
    8DM         --------------------------------------------------    14
    :ENTER      --------------------------------------------------    22
    :EXIT       --------------------------------------------------    22
    ^           --------------------------------------------------    10
    _0_         --------------------------------------------------     3
    ARRAY.4th   --------------------------------------------------    18
    AUTO-DEPTH DISPLAY  ------------------------------------------    11
    BASE        --------------------------------------------------    11
    BLOAD       --------------------------------------------------    21
    BLOCK       --------------------------------------------------    18
    BRKON       --------------------------------------------------     9
    brkon       --------------------------------------------------     9
    BYE         --------------------------------------------------     1
    C!          --------------------------------------------------    17
    C@          --------------------------------------------------    17
    Colon Definitions  -------------------------------------------    11
    COLON       --------------------------------------------------     9
    COLORTEXT   --------------------------------------------------     3
    CONST       --------------------------------------------------    18
    CONSTANT    --------------------------------------------------    17
    CREATE .. DOES  ----------------------------------------------    18
    ctrl-Break  --------------------------------------------------     9
    ctrl-Brk    --------------------------------------------------     9
    ctrl-C      --------------------------------------------------     9
    ctrl-S      --------------------------------------------------     9
    D+ D= etc.  --------------------------------------------------    17
    DATA[       --------------------------------------------------    19
    DD          --------------------------------------------------     9
    DDH         --------------------------------------------------     9
    DDICT       --------------------------------------------------    15
    DDL         --------------------------------------------------     9
    dds [ destructively display stack.]  -------------------------     6
    DDS         -------------------------------------------------     14
    DEBUG       -------------------------------------------------     15
    debug       -------------------------------------------------      7
    DEPTH       -------------------------------------------------     11
    DM          -------------------------------------------------     14
    DO..LOOP    -------------------------------------------------     16
    DO..LOOPs   -------------------------------------------------     18
    DS [ display stack ]  ---------------------------------------      6






     4th_86                      MANUAL.4TH                      page 27
    
    DS          --------------------------------------------------    14
    EMIT        --------------------------------------------------    17
    EXIT        --------------------------------------------------    18
    F1 and F2   --------------------------------------------------     3
    FLOAD       --------------------------------------------------    13
    FLOAD       --------------------------------------------------    21
    FORGET      --------------------------------------------------    12
    FORTH.INF.  --------------------------------------------------     2
    FORTH: A text and Reference  ---------------------------------     2
    FPOINT.DOC  --------------------------------------------------     8
    FRENCH.4TH  --------------------------------------------------    10
    gcolr       --------------------------------------------------     3
    HEAD        --------------------------------------------------    21
    HELP        --------------------------------------------------     1
    HILSIER2    --------------------------------------------------    23
    ILOAD       --------------------------------------------------    24
    Inline Assembler ---------------------------------------------    22
    ISAVE       --------------------------------------------------    24
    KEY         --------------------------------------------------    17
    LAST        --------------------------------------------------    21
    LEAVE       --------------------------------------------------    18
    LINK        --------------------------------------------------    12
    LOAD        --------------------------------------------------    21
    MAP         --------------------------------------------------    25
    NOS [ next on stack ] ----------------------------------------     5
    OMIT        --------------------------------------------------    22
    OOPS        --------------------------------------------------     9
    PAGE0       --------------------------------------------------     9
    PDICT       --------------------------------------------------    15
    plaintext   --------------------------------------------------     3
    PRINTLOAD   --------------------------------------------------    21
    REDEFINE    --------------------------------------------------    21
    REDIT       --------------------------------------------------    13
    RELOAD      --------------------------------------------------    13
    SECDELAY.4TH  ------------------------------------------------    22
    SECDELAY    --------------------------------------------------     9
    SHARPS.4th  --------------------------------------------------    18
    SRET        --------------------------------------------------     9
    stack depth --------------------------------------------------     3
    STATUS      --------------------------------------------------    25
    SYNONYM     --------------------------------------------------    16
    TAG         --------------------------------------------------    15
    TD          --------------------------------------------------    16
    TEST.ASM    --------------------------------------------------    21
    THREAD      --------------------------------------------------     9
    TM          --------------------------------------------------    16
    TOS [ top of stack ] -----------------------------------------     5
    TRACEL      --------------------------------------------------    15
    TRACEOFF    --------------------------------------------------    15
    TRACEON     --------------------------------------------------    15
    TUTORIAL.TXT  ------------------------------------------------     1
    TYPE        --------------------------------------------------    17






     4th_86                      MANUAL.4TH                      page 28
    
    UNLINK     ---------------------------------------------------    12
    UNSPLIT    ---------------------------------------------------     1
    UNSPLIT    ---------------------------------------------------     3
    USING      ---------------------------------------------------    13
    VARIABLE   ---------------------------------------------------    17
3$