off printload
	( ******* ERATOSTHENES SIEVE ******* )
        (    written for use with 4th_86      )	


( --- 
forget strt	
: strt ;	
  --- )
			( 4th_86 code starts here )

50  const bytes	 ( change as required up to maximum of 8191 
		     8192 raises problems with 16 bit overflow at limits
			of loop count )
bytes block bits
bytes 8 * const bitsend 


2 block mask	( bit mask to access bits in each byte )
2 block curbyte	( current byte address in flag array )
2 block curbit	( current bit in curbyte )


2 block ii	( outer  begin .. end loop counter )
2 block jj	( inner  begin .. end loop counter )

		( NOTE - these are not begin .. end construct loop counters 
		  per se -- although they echo their current value.
		   reference to ii and jj are  used by word GETPARMS )


2 block pre-addition

2 block count	( total number of primes found )
2 block lcount	( count for line formatting )


( ******************* 
  initialise various things
  ******************* )

: setup bytes 1+ 0 do
                 0 bits i + b!     ( set all bits in array to zero )
                loop
	2 ii ! 	 0 jj !	  	   ( initial values for loop counts )
	0 count !  0 lcount !	   (  primes and display formatting counter )
;


( ******************* 
  recalculate curbyte curbit and mask
  from loop counter.
  ******************* )

: getparms

     @ dup 3 ->L bits + curbyte ! 	( divide by 8 )
	      7 and dup curbit !	( remainder is curbit -- 0 thru 7 )
	      1 swap <-L mask !		( use curbit to set mask )
;


( ******************* 
  write "1"s into selected bits of array
  ******************* )

: another-prime

jj @ dup + 	( loop start count = 2 * jj )
begin

	jj getparms ( calculate current curbyte etc for this loop )

	curbyte @ b@ mask @  or curbyte  @ b!  ( cancel multiples ) 

					
	jj @ pre-addition !	( jj before ii added )

	ii  @ jj +!  		( bump loop counter by current value of ii )

	pre-addition @ 		( jj before ii added )
	jj @ 			( jj after ii added )

	U> if 			( 16 bit overflow has occured in addition )
		bitsend 1 + jj ! 	( so set it to exit value  )
	   then 

	jj @  bitsend  U> 
end 	

	drop  
	ii getparms ( reset curbyte etc to current outer loop value )
;


( ******************* 
  test array to see if bits are set or not
  ******************* )

: primes
	setup  
	ii getparms 	( calculate initial values of curbyte etc )

2 begin					( begin with first prime - ie 2 )

	ii @ jj ! 			( jj will be referenced by inner loop ) 

	curbyte @ b@  mask @ and  	( find if current bit is set or not )

	  0=  if 		( we've got another prime )
		1 count +! 	( increment count of # primes )
		1 lcount +!	( bump count of display output )
		lcount @ 12 >   ( has it reached 12 values per line )

		      if
				0 lcount ! crlf   ( start a new display line )
		      then	
				  ii @ .U    ( display prime on screen ) 
		another-prime	( look for next prime )  
	      then

	1 ii +!				( bump loop counter by one )
	ii getparms			( ready to return to outer loop again )
	ii @  bitsend  U> 		( finished loop yet ? )

end 

	drop 

crlf crlf " total number of primes found =" ." count @ .u
;
							
( ******************* )
  primes		( go do it )

		
( --- 
*** Algorithm is based on the following C code version 

*** /*	Eratosthenes Sieve Prime Number Program in C, Byte January 1983.
*** */
*** #include <stdio.h>
*** 
*** #define TRUE	1
*** #define FALSE	0
*** #define NITER	150
*** #define SIZE	8190
*** 
*** char flags[SIZE+1]={0};
***
*** main ()
*** 	{
*** 	register int i,k;
*** 	int iter, count;
*** 
*** 	printf ("%d iterations: ", NITER);
*** 
*** 	for( iter = 1; iter <= NITER; iter++ )     /* Do sieve 150 times */
*** 		{
*** 		count = 0;
*** 		for( i = 0; i <= SIZE; i++)	  /* set all flags true */
*** 			flags[i] = TRUE;
*** 
*** 		for( i = 2; i <= SIZE; i++ )
*** 			{
*** 			if ( flags[i] )		  /* found a prime */
*** 				{
*** 				for ( k = i + i; k <= SIZE; k += i )
*** 					flags[k] = FALSE;	/* Cancel its multiples */
*** 				count++;
*** 				}
*** 			}
*** 		}
*** 
*** 	printf ("%d primes\n", count);
*** 
*** 	exit(0);
*** 
*** 	}
*** 
--- )
